<?php

function Get_Multiple_Browse_Folder_Links($disk, $disknick, $parentdirs, $getvars)
{
	// 14:49:19 3/3/2014.  Used by the file lister.
	#echo "Parentdirs only : $parentdirs " ;
	
	$fragmentized_parentdirs=explode("/", $parentdirs);
	
	//$rebuilt_parentdirs="file://localhost/$disk:";
	$rebuilt_parentdirs = "";
	$result = "<a href=\"file://localhost/$disk:/\">$disk:</a> ";
	
	
	foreach ($fragmentized_parentdirs as $dir)
	{
		$rebuilt_parentdirs .= "/" . $dir;
		
		$result .= " &nbsp; ";
		$result .= Get_File_Lister_Browse_Folder_Link($disknick, $rebuilt_parentdirs, false, $getvars, $dir);
	}
	return $result;
	
}

function Get_Multiple_Folder_Links($disk, $disknick, $parentdirs)
{
	// 14:49:19 3/3/2014.  Used by the file lister.
	#echo "Parentdirs only : $parentdirs " ;
	
	$fragmentized_parentdirs=explode("/", $parentdirs);
	
	$rebuilt_parentdirs="file://localhost/$disk:";
	
	$result = "<a href=\"file://localhost/$disk:/\">$disk:</a> ";
	
	
	foreach ($fragmentized_parentdirs as $dir)
	{
		$rebuilt_parentdirs .= "/" . $dir;
		$result .= " &nbsp; <a href=\"$rebuilt_parentdirs\">$dir</a> ";
	}
	return $result;
	
}






function Get_File_Lister_Browse_Folder_Link($disknick, $folder, $make_brown_browse_link=false, $getvars="", $label = "", $itemtype=false)
{	// 14:46:12 3/3/2014.  Used by folder structure outputter (the best version).

	global $file_db_to_use, $disk_aliases, $webpath_of__abdesktop;
	
	#echo "<pre>";
	#PrintArr($disk_aliases) ;
	
	if ( isset($disk_aliases[$disknick] ) )
	{
		$disk=key($disk_aliases[$disknick]);
	}
	else
	{
		$disk="Unknowndisknick";
	}
	if (!$getvars)
	{	$getvars = "&db=$file_db_to_use&a=desc&g=y&n=15&o=fileinfo.file_id desc&inc=rep,triv,stat,unk,maybe,timecap,data,scour,prm,mir";
	}
	if (!$label)
	{	$label="Browse";
	}
	$folder=ltrim($folder, "/");
	
	$windows_format_folder_path = "$disk:/$folder";
	
	if ($make_brown_browse_link)
	{
		$class="op3";
	}
	else
	{	$class="op2";
	}
	$browselink="<span class='$class'><a href=\"$webpath_of__abdesktop/files/list-files.php?p=0$getvars&xq=browse $windows_format_folder_path\"  onclick='change=false'>$label</a></span>";
	
	return $browselink;
}




function PrintDBsList($dbtype, $noisy=true, $linked=true, $linkloc=false, $destination_db=false, $number_to_add_to_radioboxset_name=false)
{	global $finalgetvars, $page, $webpath_of__abdesktop, $width_of_db_list;

	$res="";
	
	$dbsarrname="$dbtype" . "_dbs";
	$dbvarname="$dbtype" . "_db_to_use";
	
	$display_names_for_db = "display_names_for_$dbtype" . "_dbs";
	
	global ${$dbsarrname};
	global ${$dbvarname};
	global ${$display_names_for_db};
	
	//PrintArr(${$dbsarrname}, $dbsarrname);
	//echo "<p>";

	$x=0;
	$res .= "<center><a name=\"dbslist\"></a><table class='dbslist'>";
	foreach (${$dbsarrname} as $db)
	{	
		if ($db == "changewidthto4" )
		{	$width_of_db_list=4;
			#$res .= "<tr><td>";
			$x=0;
			continue;
		}
		if ($x%$width_of_db_list==0)
		{	$res .= "<tr><td>";
		}
		
		#echo " display_names_for_db : $display_names_for_db ";
		if ( isset( ${$display_names_for_db}["$db"] ) )
		{
			$dispdb = ${$display_names_for_db}["$db"];
		}
		else
		{
			$dispdb=ucwords($db);
		}
		$res .= "<td class='dbslist'><INPUT TYPE=RADIO NAME=\"radiobox_selected_" . $dbtype . "_db";
		
		if ($number_to_add_to_radioboxset_name)
		{	$res .= $number_to_add_to_radioboxset_name;
		}	
		
		$res .= "\" VALUE=\"$db\" ";
		
		if (!$destination_db)
		{	
			if ($db==${$dbvarname} )
			{	//echo "dblist DB: $db  DBvarname: $dbvarname  ${$dbvarname}  Filesdbname: $file_db_to_use ";
	//	echo " db $db dbvarname ${$dbvarname} ";
		//<br>";
				$res .= "checked";
				
			}
		}
		else if ($destination_db && $destination_db!="DO NOT PUT A CHECK NEXT TO CUR DB")
		{	//echo ">destination_db: $destination_db dbvarname $dbvarname ${$dbvarname}<br>";
			if ($db==$destination_db )
			{	
				$res .= "checked";
			}
		}
		$res .= ">&nbsp;";
		if ($db==${$dbvarname})
		{	$res .= "<b>";
		}
		if ($linked)
		{	
			if ($linkloc=="lister")
			{	if (!$finalgetvars)
				{
					//$incs="&inc=all";
					$finalgetvars="&inc=all&plpre=y";
				}
				$linkdest=$webpath_of__abdesktop . "/$dbtype" . "s/list-$dbtype" . "s.php?g=y&p=$page$finalgetvars&db=$db";
				
			}
			$res .= "<a href=\"$linkdest\">$dispdb</a>";
			//$res .= "<a href=\"$_SERVER['PHP_SELF']?p=$page$finalgetvars&db=$db\">$dispdb</a>";
		}
		else
		{	$res .= $dispdb;
		}
		if ($db==${$dbvarname})
		{	$res .= "</b>";
		}
		
		if ($dbtype=="file")
		{
			$linkdest=$webpath_of__abdesktop . "/$dbtype" . "s/not-in-abdesk-3_0/output_folder_structure.php" . "?db=$db";
		
			$res .= "<td class='dbslist'><a href='$linkdest'><big>&#x2745;</big></a>";
		}
		
		$x++;
	}
	$res .= "</span></table></center>";
	if ($noisy)
	{	echo $res;
	}
	else
	{	return $res;
	}
}



function Print_Links_for_DB_Folder_Structure($dbtype, $noisy=true )
{	global $webpath_of__abdesktop, $width_of_db_list;
	$dbsarrname="$dbtype" . "_dbs";
	$dbvarname="$dbtype" . "_db_to_use";
	
	global ${$dbsarrname};
	global ${$dbvarname};
	
	//PrintArr(${$dbsarrname}, $dbsarrname);
	//echo "<p>";

	$x=0;
	$res .= "<center><table>";
	foreach (${$dbsarrname} as $db)
	{	
		if ($x%$width_of_db_list==0)
		{	$res .= "<tr><td>";
		}
		$dispdb=ucwords($db);
				
		$linkdest=$webpath_of__abdesktop . "/$dbtype" . "s/not-in-abdesk-3_0/output_folder_structure.php" . "?db=$db";
		
		$res .= "<td class='dbslist'><a href='$linkdest'>$dispdb</a>";
		
		$x++;
	}
	$res .= "</span></table></center>";
	if ($noisy)
	{	echo $res;
	}
	else
	{	return $res;
	}
}

