<?php
$current_organizer="idea";
require ("../lib-abdesk.php");
CheckCookie();
session_start();


$variables_to_initialize = array (

"list_of_bad_numboxes", "sqlvals", "x", "tags_changed", 

 );

InitializeVariables ( $variables_to_initialize );


$dbtype="idea";
$prevformname="idea_record_editor_form";
$errorvarname="idea_record_editor_error";

 	$varsforquery1=array("bundlestring", "title", "authorstring", "whenotedstring", "relatedids", "otherbundlestring", "status", "aesthetic", "utilit", "educational", "humorous", "forfun", "curio", "observation", "opinion", "projectstring", "languagestring", "urls", "maintagstring", "othertagstring", "repository", "note", "todo", "important", "obsolete", "trivial",  "tip", "activity", "fav", "clutterpile", "scrapbook", "frequent", "question", "goal", "recurrent", "junkpile", "forother", "quotebelow", "listitem", "definite", "tentative", "hide", "aside", "archive", "usefulness", "fun", "beauty", "priority", "rpriority", "plausibility", "necessity", "humorousness", "liking", "eduval", "quality", "interest", "forsite", "finishbydatestring", "notesonduedate",  "othercomments", "filepaths", "whendonestring", "done", "iced", "donenote", "whenadded", "whenoted", "finishbydate", "whendone", "maindateyear", "maindatemonth", "maindateday", "maindatetime", "datestartyear", "datestartmonth", "datestartday", "datestarttime", "datendyear", "datendmonth", "datendday", "datendtime", "maindatenotes", "daterangenotes", "unhide", "locstring", "toforstring", "originstring", "arbitrary_number", "quotelength", "longdesclength");
	
	$varstoget_fromform=$varsforquery1;
	//array_push($varsforquery1, "quotelength");
	//array_push($varsforquery1, "longdesclength");
	
	$varsforaltqueries=array("quote", "longdesc", "sourcenotes");
	
	foreach ($varsforaltqueries as $var)
	{	$varsforqueryname="varsforquery$var";
		${$varsforqueryname}=array("$var");
		array_push($varstoget_fromform, "$var");
	}

		
require ("../lib-tags.php");

function GoBackToFormWithError($err, $extra_getvars)
{	global $idea_id, $prevformname, $errorvarname;

	$_SESSION[$errorvarname]=$err;
	header("Location: $prevformname.php?id=$idea_id$extra_getvars");
	exit;
}

$radiobox_selected_idea_db=GetFromArray($_POST, 'radiobox_selected_idea_db');
$idea_db_to_use=$radiobox_selected_idea_db;

$_SESSION['radiobox_selected_idea_db']=$radiobox_selected_idea_db;

$lock=GetFromArray($_POST, 'lock');
$_SESSION['lock']=$lock;

$record_copy_mode=GetFromArray($_POST, 'record_copy_mode');
$_SESSION['record_copy_mode']=$record_copy_mode;

$fromdb=GetFromArray($_POST, 'fromdb');
$_SESSION['fromdb']=$fromdb;

$selected_text=GetFromArray($_POST, 'selected_text');
$_SESSION['selected_text']=$selected_text;


$idea_id=GetFromArray($_POST, 'idea_id'); //If the previous page was an
	//Edit page, then, the ID will be here (delivered by a hidden
	//field on the last page).

//We want to keep "raw" copies of the following variables, obtained prior to running the CleanInput function on $_POST,
	//since it's easier to compare the raw, non-escaped copies to the "prev" versions of those variables to ascertain 
	//whether the new data is different from the old data or not.
	
	$raw_varstomake=array("maintagstring", "othertagstring", "projectstring", "bundlestring", "authorstring", "languagestring", "otherbundlestring", "whenotedstring", "whenoted", "finishbydate", "locstring", "toforstring", "originstring", "whendone");

	foreach ($raw_varstomake as $current_var)
	{	
		$rawvarname="raw_$current_var";
		${$rawvarname}=GetFromArray($_POST, $current_var);
	}

//$action="Add"; //Just in case.  Add would do less damage than Edit, so we want Add by default.

if (!$idea_id || $record_copy_mode || $fromdb) //$idea_id==0 
{	$action="Add"; //This means we're adding a new idea, and can avoid doing certain things
						//that are necessary if we're editing an existing idea.
} else if ($idea_id && !$record_copy_mode && !$fromdb)
{	$action="Edit";	//This means we're editing an idea already in the database.  So, this means we have to figure out
						//whether or not some of the data the user input is different from the original data.
						
		//Prev vars are only present if we're editing a previous idea.  So, we retrieve them here.
	//These make it possible to tell (without querying the DB) if a namestring or tagstring was changed.
	$prev_varstomake=array("maintagstring", "othertagstring", "projectstring", "bundlestring", "authorstring", "languagestring", "otherbundlestring", "locstring", "toforstring", "originstring");
	
	foreach ($prev_varstomake as $current_var)
	{	$prevvarname=substr($current_var, 0, -5); //Getting rid of "tring" at the end.
		$prevvarname="prev$prevvarname";
		${$prevvarname}=GetFromArray($_POST, $prevvarname);
		$_SESSION[$prevvarname]=GetFromArray($_POST, $prevvarname);
		
		//01:08 03/25/2011.  Tentatively commented out, maybe not needed:
	//	echo "Former ereg_replace: $prevvarname ${$prevvarname}<br>";
		//${$prevvarname}=str_replace("&quot;", "\"", ${$prevvarname}); //12:49 PM, 3/17/2011.  ereg_replace removed
		//echo "Former ereg_replace2: $prevvarname ${$prevvarname}<br>";
	}		
	//Onward.  Most of the tag stuff is handled at the end, but some is in the middle.
}

if (!$action)
{
	GoBackToFormWithError("no action selected", $extra_getvars);
	exit;
}

//$action="Add"; //Just in case.  Add would do less damage than Edit, so we want Add by default.

	foreach ($varstoget_fromform as $varname)
	{
		$_SESSION[$varname]=GetFromArray($_POST, $varname);
	}

	if ($record_copy_mode)
	{	
		$extra_getvars = "&db=$fromdb";
	}	
	else
	{	$extra_getvars = "&db=$radiobox_selected_idea_db";
	}
	if ($record_copy_mode)
	{
		$extra_getvars.="&record_copy_mode=$record_copy_mode&selected_text=$selected_text&error_happened=y";
	}

	
if (!$radiobox_selected_idea_db)
{	
	GoBackToFormWithError("no db selected", $extra_getvars);
	exit;
}
//GoBackToFormWithError("no db selected", $extra_getvars);

$handle=ConnectToDb($radiobox_selected_idea_db, false, "dont die");

if ($handle=="mysql_pconnect error" || $handle=="mysql_select_db error")
{	DisplayWithError(mysql_error(), 2);
	
	if ($handle=="mysql_pconnect error")
	{	
		GoBackToFormWithError("mysql_pconnect error", $extra_getvars);
		//echo mysql_error();
		exit;
	}
	else if ($handle=="mysql_select_db error")
	{	$uc_db=ucwords($radiobox_selected_idea_db);
		DisplayWithError($uc_db, 3);
		GoBackToFormWithError("mysql_select_db error", $extra_getvars);
		//echo mysql_error();
		exit;
	}
}

//echo "Handle: $handle";

$dateparsers=array("maindateparser", "startdateparser", "enddateparser");

foreach ($dateparsers as $parsername)
{	
	$_SESSION[$parsername]=GetFromArray($_POST, $parsername);
}

array_walk($_POST,'CleanInput');  

	$idea_id=GetFromArray($_POST, 'idea_id');

	foreach ($varstoget_fromform as $varname)
	{	${$varname}=GetFromArray($_POST, $varname);
	}

function CleanUpRelatedIDs($ids)
{	
	$arr=explode(";", $ids);		
	$arr=CleanUpArray($arr);
	
	$res=implode("; ", $arr);
	return $res;
}

function CleanUpArray($arr)
{
	array_walk($arr, 'RemoveWhitespaceEtcFromTagArr');
	$arr=ArrRemoveEmptyValues($arr);
	$arr=array_iunique($arr);
	
	//This bit here is just to make the array continuous instead
	//of having gaps:
	$arr=array_merge($arr);
	return $arr;
}
function CleanUpURLBatch($urls)
{	
	$arr_urls=explode("\\r\\n", $urls);
	$arr_urls=CleanUpArray($arr_urls);
	$res=implode("\\r\\n", $arr_urls);
	return $res;
}

$relatedids=CleanUpURLBatch($relatedids);
$urls=CleanUpURLBatch($urls);
$filepaths=CleanUpURLBatch($filepaths);

	$tagstring_vars=array("maintagstring", "othertagstring", "projectstring", "bundlestring", "authorstring", "languagestring", "otherbundlestring", "locstring", "toforstring", "originstring");

	$changed_tagtypes=array();
	//Then we figure out if the new raw tagstring variables are different from the previous tagstring variables,
	//and clean up any changed tagstrings.
	
	foreach ($tagstring_vars as $tagstringvar)
	{
		$rawtagstringvar="raw_$tagstringvar";
		if ($action=="Edit")
		{	$prevtagstringvar="prev$tagstringvar";
			$prevtagstringvar=substr($prevtagstringvar, 0, -5); //Getting rid of "tring" at the end.
		}
		$thistagtype=substr($tagstringvar, 0, -6); //Gets rid of "string" at the end.

		if ( ($action=="Edit" && ${$rawtagstringvar} != ${$prevtagstringvar} ) || ($action=="Add" && ${$rawtagstringvar} ) )
		{
				$tags_changed="true";
			${$tagstringvar}=CleanUptagstring( ${$rawtagstringvar} );
		
			$quotelessvar="quoteless_" . $tagstringvar;		//Later on, the tagstring vars are going to end up
			${$quotelessvar}=${$tagstringvar};		//surrounded by quotes for input into the ideainfo table, so we
												//want to preserve a nice, untouched copy of the cleaned-up
											//tagstrings without quotes for when we input the tags into the tags DB.
			array_push($changed_tagtypes, $thistagtype);
		}
	}

$nowtimestamp=GetNowTimestamp();

foreach ($dateparsers as $parsername)
{	${$parsername}=GetFromArray($_POST, $parsername);
}

foreach ($dateparsers as $parsername)
{
	if (${$parsername} )
	{	$thistimestamp=MakeIntoUnixTimeWithErrorReturn(${$parsername} );
	
		if ($thistimestamp=="invalid timestamp")
		{	GoBackToFormWithError("invalid timestamp", $extra_getvars);
			exit;
		}
		$thismonth=date("n", $thistimestamp);
		$thisday=date("j", $thistimestamp);
		$thisyear=date("Y", $thistimestamp);
		$thistime=date("H:i:s", $thistimestamp);
		if ($thistime=="00:00:00")
		{	$thistime=null;
		}
		switch ($parsername)
		{	case "maindateparser": $maindatemonth=$thismonth;
									$maindateday=$thisday;
									$maindateyear=$thisyear;
									$maindatetime=$thistime; break;
			case "startdateparser": $datestartmonth=$thismonth;
									$datestartday=$thisday;
									$datestartyear=$thisyear;
									$datestarttime=$thistime; break;
			case "enddateparser": $datendmonth=$thismonth;
								$datendday=$thisday;
								$datendyear=$thisyear;
								$datendtime=$thistime; break;
		}
	}
}

$months=array("maindatemonth", "datestartmonth", "datendmonth");

foreach ($months as $month)
{
	if (${$month} || ${$month}==="0")
	{
		if (${$month} > 12 || ${$month}<1)
		{
			GoBackToFormWithError("invalid month", $extra_getvars);
			exit;
		}
	}
}
/*
if ($maindatemonth>12 || $datestartmonth>12 || $datendmonth>12 || $maindatemonth<1 || $datestartmonth<1 || $datendmonth<1)
{
	GoBackToFormWithError("invalid month", $extra_getvars);
	exit;
}*/

$days=array("maindateday", "datestartday", "datendday");

foreach ($days as $day)
{
	if (${$day} || ${$day}==="0")
	{	
		if (${$day} > 31 || ${$day} <1)
		{	GoBackToFormWithError("invalid day", $extra_getvars);
			exit;
		}
	}
}

/*
if ($maindateday>31 || $datestartday>31 || $datendday>31 || $maindateday<1 || $datestartday<1 || $datendday<1)
{
	GoBackToFormWithError("invalid day", $extra_getvars);
	exit;
}*/


$times=array("maindatetime", "datestarttime", "datendtime");

foreach ($times as $time)
{	
	if ( ${$time} )
	{	$timestamp=$time . "timestamp";
		${$timestamp}=strtotime(${$time});
		if (${$timestamp}===false)
		{	GoBackToFormWithError("invalid time", $extra_getvars);
			exit;
		}
		${$time}=date("H:i:s", ${$timestamp});
	}
}

if (!$whenadded && $action=="Add") //"Edit"
{	$whenadded=$nowtimestamp;
}

$itemid=$idea_id;

if ($whenotedstring)	//The user input a when-noted date, so we grab the timestamp.
{	$whenoted=GetTimestampWithErrorReturn($raw_whenotedstring);
//echo "Whenoted: '$whenoted' ";

	if ($whenoted=="invalid timestamp")
	{	//echo "Yeah $extra_getvars";
//	exit;
		GoBackToFormWithError("invalid timestamp", $extra_getvars);
		exit;
	}
}
else	//If the user didn't input a when-noted date...
{
		$whenoted=$whenadded;
		$whenotedstring=$whenoted;
}

if ($finishbydatestring)
{	
	$finishbydate=GetTimestampWithErrorReturn($finishbydatestring);
	if ($finishbydate=="invalid timestamp")
	{
		GoBackToFormWithError("invalid timestamp", $extra_getvars);
		exit;
	}
}

if ($whendonestring)
{	$whendone=GetTimestampWithErrorReturn($whendonestring);
	if ($whendone=="invalid timestamp")
	{
		GoBackToFormWithError("invalid timestamp", $extra_getvars);
		exit;
	}
}

$checkboxes = array(&$repository, &$note, &$important, &$obsolete, &$trivial, &$activity, &$fav, &$clutterpile, &$frequent, &$question, &$goal, &$recurrent, &$junkpile, &$forother, &$quotebelow, &$listitem, &$definite, &$tentative, &$hide, &$archive, &$aside, &$done, &$iced, &$status, &$aesthetic, &$utilit, &$educational, &$forfun, &$humorous, &$curio, &$observation, &$tip, &$todo, &$opinion, &$scrapbook, &$unhide);

$numberboxes = array(&$usefulness, &$fun, &$beauty, &$priority, &$rpriority, &$plausibility, &$necessity, &$humorousness, &$liking, &$eduval, &$quality, &$interest, &$arbitrary_number);

$numberboxes = array("usefulness", "fun", "beauty", "priority", "rpriority", "plausibility", "necessity", "humorousness", "liking", "eduval", "quality", "interest", "arbitrary_number", "maindatemonth", "maindateyear", "maindateday", "datestartmonth", "datestartyear", "datestartday", "datendmonth", "datendyear", "datendday");

foreach ($numberboxes as $thisbox)
{
	if (${$thisbox} && !is_numeric(${$thisbox} ) )
	{	$disp_box=ucwords($thisbox);
		$list_of_bad_numboxes .= " $disp_box ";
	}
}
$list_of_bad_numboxes=trim($list_of_bad_numboxes);
if ($list_of_bad_numboxes)
{
	DisplayWithError($list_of_bad_numboxes, 2);
	GoBackToFormWithError("num boxes must contain nums", $extra_getvars);
	exit;
}

	
FixCheckboxValues();
//FixNumberboxValues();


if ( ($iced=="y" || $done=="y" ) && !$whendone)
{	$whendone="$nowtimestamp";
	$whendonestring=$whendone;
}

if ( ($iced=="n" && $done=="n") && $whendone)
{	$whendone="NULL";
	$whendonestring="NULL";
	GoBackToFormWithError("done or iced", $extra_getvars);
	exit;
}

$titleunquoted=$title;
$bundlestringunquoted=$bundlestring;
$prioritycss=$priority;
if ($prioritycss=="NULL")
{	$prioritycss="";
}

$quotelength=strlen($quote);
$longdesclength=strlen($longdesc);

$nowtimestamp=GetNowTimestamp();


if ($action=="Edit")
{
	$allqueryparts1=MakeQueryParts($idea_id, $varsforquery1);
	$allqueryparts1=TrimComma($allqueryparts1);
	
	foreach ($varsforaltqueries as $var)
	{	$vars_arrname="varsforquery$var";	
		$allquerypartsname="allqueryparts$var";
		
		${$allquerypartsname}=MakeQueryParts($idea_id, ${$vars_arrname});
		${$allquerypartsname}=TrimComma(${$allquerypartsname} );
	}
}
else
{	EncloseOrNullAll($varsforquery1);

	foreach ($varsforaltqueries as $var)
	{	$vars_arrname="varsforquery$var";
		EncloseOrNullAll(${$vars_arrname});
	}
}
$display_name_of_idea_db_being_used=ucwords($radiobox_selected_idea_db);
echo "<html><head><title>";

if ($action=="Add")
{
	if ($record_copy_mode)
	{	$disp_fromdb=ucwords($fromdb);
	}
	if ($record_copy_mode=="y")
	{	
		echo "Idea #$idea_id from $disp_fromdb Xferred to $display_name_of_idea_db_being_used";
	}
	else if ($record_copy_mode=="clipping")
	{	echo "Clipping from Idea #$idea_id from $disp_fromdb Added to $display_name_of_idea_db_being_used";
	}
	else if (!$record_copy_mode)
	{	echo "Idea Added to $display_name_of_idea_db_being_used";
	}
}
else if ($action=="Edit")
{
	echo "Idea $idea_id $action" . "ed" . " in $display_name_of_idea_db_being_used";
}

echo "</title>
<link rel=stylesheet href='css/i.css' type='text/css'>
</head>
<body><center>";

AllOrganizerNavLinks();

echo "<p><br><h1>";

$bundlestring_and_title = "<span class='p$prioritycss'>";
$bundlestring_and_title .= GetBundlestringText($bundlestringunquoted);
$bundlestring_and_title .= " " . $titleunquoted;

if ($record_copy_mode=="clipping")
{	echo "Clipping from ";
}
	
echo "Idea $idea_id ";
if ($record_copy_mode!=="clipping")
{
	echo "$bundlestring_and_title</span>";
}
echo "<br>";

if ($action=="Add")
{	if ($record_copy_mode)
	{	
		echo "from $disp_fromdb<p>";
		if ($record_copy_mode=="y")
		{	echo "Copied";
			echo " (Added)";
		}
		else
		{	echo "Added";
		}
	}
	else
	{	echo "Added";
	}
	echo " to ";
}
else
{
	echo "Edited in ";
}
echo "$display_name_of_idea_db_being_used";

echo "</h1></center>";

//echo "Idea $idea_id ";

//<span class='p$prioritycss'>";

//$output=GetBundlestringText($bundlestringunquoted);

//echo "$output $titleunquoted</span><br><br>$action";

/*echo "ed ";
if ($action=="Add")
{	echo "to";
}
else
{	echo "in";
}
echo " $display_name_of_idea_db_being_used</h1></center>";
*/

echo "<p>
<br>
<div id=\"maintext\">";

	$sqlvarstoinsert1=implode(", ", $varsforquery1);
	$sqlvals1=MakeSQLInsertVals($varsforquery1);
	
	foreach ($varsforaltqueries as $var)
	{
		$vars_arrname="varsforquery$var";
		
		$sqlvars_name="sqlvarstoinsert$var";
		${$sqlvars_name}=implode(", ", ${$vars_arrname} );
		$sqlvalsname="sqlvals$var";
		${$sqlvalsname}=MakeSQLInsertVals(${$vars_arrname} );
	}

if ($action=="Add")
{	$query_to_issue = "INSERT INTO ideainfo ($sqlvarstoinsert1, lastread)";
	$query_to_issue .= " VALUES ($sqlvals1, '$nowtimestamp')";

}

if ($action=="Edit")
{
	$query_to_issue="UPDATE ideainfo SET whenmodified='$nowtimestamp' ";
	if ($allqueryparts1)
	{	$query_to_issue .= ", $allqueryparts1";
	}
	$query_to_issue .= " WHERE idea_id=$idea_id LIMIT 1 ";
	
}

echo "<p><b>Main query:</b> <code>$query_to_issue";
echo "</code><p>";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

if ($action=="Edit")
{	
	foreach ($varsforaltqueries as $var)
	{	$queryname="query$var";
		$allquerypartsname="allqueryparts$var";
		if (${$allquerypartsname} )
		{
			$ucvar=ucwords($var);
			${$queryname} = "UPDATE idea$var SET " . ${$allquerypartsname} . " WHERE idea_id=$idea_id LIMIT 1";
			echo "<b>$ucvar query:</b> <code>${$queryname}</code><p>";
			$query_result=mysql_query(${$queryname},$handle) or die(mysql_error());
		//INTO idea$var ($var) VALUES 
		}
	}
}
if ($action=="Add")
{	
	$idea_id = mysql_insert_id();
	
	foreach ($varsforaltqueries as $var)
	{	$queryname="query$var";
		$sqlvalname="sqlvals$var";
		${$queryname} = "INSERT INTO idea$var ($var, idea_id) VALUES (" . ${$sqlvalname} . ", $idea_id )";
		$ucvar=ucwords($var);
		echo "<b>$ucvar query:</b> <code>${$queryname}</code><p>";
		$query_result=mysql_query(${$queryname},$handle) or die(mysql_error());
	}
	
}


//Now, we handle the tags.

if ($tags_changed)
{	
	ManageTags("idea", $idea_id);
}

if ($action=="Edit")
{
	//Now we get rid of some no longer needed session variables set up by the previous form.
	
	RemoveFormSessionVars($varstoget_fromform, $idea_id);
	
	foreach ($dateparsers as $parsername)
	{	
		unset($_SESSION[$parsername]);
	}
}
echo "<center><p><br><br>";

AllOrganizerNavLinks();
echo "<p>";
echo "</body></html>";
