<?php
$current_organizer="url";
require ("../lib-abdesk.php");

CheckCookie();
session_start();

InitializeVariables ( array( "reassign_keys", "dupurls", "unusedlines", "clean_urlset_scrapedwebtitles", "execute_insert_query", "updateids", "curtimestamp", "existing_urls", "altqueries", "existing_urlids", 
)
);

require ("../lib-urls.php");


$remove_commas_from_dates_before_periods=true;

$errorvarname="multi_url_adder_error";
$prevformname="multi_url_adder_form";

function GoBackToFormWithError($err)
{	global $prevformname, $errorvarname, $radiobox_selected_url_db;
	$_SESSION[$errorvarname]=$err;
	header("Location: $prevformname.php?db=$radiobox_selected_url_db");
	exit;
}

function array_idiff($array1, $array2) 
{ 
	foreach ($array1 as $key=>$element) 
	{ 
		 foreach($array2 as $key2=>$element2) 
		 { 
			 if (strtolower($element) == strtolower($element2)) 
			 { 
				 unset($array1[$key]); 
			 } 
		 } 
	} 
	$diff = array_values($array1);
	return $diff; 
}

$sessprefix="url_organizer__multiadder";

$varstoget=array("urls", "dateofcollection", "sourcenotes", "shortdesc", "revinputorder", "inputformat", "lock", "radiobox_selected_url_db");

//"inputformat", "revinputorder", "sourcenotes");

foreach ($varstoget as $var)
{
	$sessvar=$sessprefix . "_$var";
	$_SESSION[$sessvar]=GetFromArray($_POST, $var);
}


$radiobox_selected_url_db=GetFromArray($_POST, 'radiobox_selected_url_db');

if (!$radiobox_selected_url_db)
{	
	GoBackToFormWithError("no db selected");
	exit;
}

$url_db_to_use=$radiobox_selected_url_db;

$handle=ConnectToDb($url_db_to_use, false, "dont die");

if ($handle=="mysql_pconnect error" || $handle=="mysql_select_db error")
{	DisplayWithError(mysql_error(), 2);
	
	if ($handle=="mysql_pconnect error")
	{	
		GoBackToFormWithError("mysql_pconnect error", $extra_getvars);
		//echo mysql_error();
		exit;
	}
	else if ($handle=="mysql_select_db error")
	{	$uc_db=ucwords($radiobox_selected_idea_db);
		DisplayWithError($uc_db, 3);
		GoBackToFormWithError("mysql_select_db error", $extra_getvars);
		//echo mysql_error();
		exit;
	}
}

$rawurls = GetFromArray($_POST, 'urls');

if (!$rawurls)
{	GoBackToFormWithError("no urls");
	exit;
}

$sourcenotes=GetFromArray($_POST, 'sourcenotes');
$shortdesc=GetFromArray($_POST, 'shortdesc');
$inputformat=GetFromArray($_POST, 'inputformat');
$revinputorder=GetFromArray($_POST, 'revinputorder');

$coldate_overrider=GetFromArray($_POST, 'dateofcollection');

if ($coldate_overrider)
{	
	#echo "coldate_overrider detected! $coldate_overrider <p> ";
	
	$timestamp = strtotime($coldate_overrider);

	if ($timestamp===false)
	{	GoBackToFormWithError("invalid timestamp");
		exit;
	}
	
	$clean_coldate_overrider=MakeRawDateClean($coldate_overrider);

	$coldate_overrider_time = MakeIntoUnixTime($coldate_overrider);
	$coldate_overrider_timestamp = date("Y-m-d H:i:s", $coldate_overrider_time);
}

CleanInput($shortdesc);
CleanInput($sourcenotes);


$arr_urls=explode("\r\n", $rawurls);
array_walk($arr_urls, 'RemoveWhitespaceEtcFromTagArr');
$arr_urls=ArrRemoveEmptyValues($arr_urls);
$arr_urls=array_merge($arr_urls);

$unusednum=0;
$linenum=0;
$urlsetnum=0;
$urlset_dates=array();
$urlset_timestamps=array();
$urlset_urls=array();
$urlset_scrapedwebtitles=array();
$urlset_shortdescs=array();
$curdate="";
$urlnum=-1;

if ($inputformat=="urlhistory_apmod") 	//Easier to parse than original input format.
					
{	//Example line:
	//http://www.astro.com/cgi/swetest.cgi?arg=-h&p=0 - 16:19:53 7/5/2010 +++ Swiss Ephemeris Test Output - Astrodienst  +++ 
	
	//First, a url.  Then, a space/dash/space followed by a datimestamp.  Then space/3 plus signs/space and the scrapedwebtitle. Then space/3 more plus signs/optional space and any user comments (shortdesc).
	
	//echo "WHEEEEEE";
	$lines=$arr_urls;
	unset($arr_urls);
	$arr_urls=array();
	$urlnums_to_skip=array();
	$dupurls=array();
	$numofdups=0;
	foreach ($lines as $line)
	{	$urlnum++;			//Every line has a URL and a different date, so these two things both
		$urlsetnum++;		//get updated on each loop.
		$key=false;
		$dup_url_found=false;
		//URL
		
		$dashloc=LocateStringIn($line, " - ");
		$thisurl=substr($line, 0, $dashloc);
		//echo "Thisurl: $thisurl";
		$key=array_search($thisurl, $arr_urls);
		//echo "Key: $key ";
		if ($key!==false)
		{	$dup_url_found=true;
		//	echo "Key: $key ";
			$numofdups++;
			array_push($urlnums_to_skip, $key);
			$dupurls[$numofdups]=$thisurl;
			
		}
		//else
		//{	//echo "<p><br>";
			if (!$dup_url_found)
			{	
				$urlset_urls[$urlsetnum][$urlnum]=$thisurl;
			}
			if (!$dup_url_found)
			{	$arr_urls[$urlnum]=$thisurl;
			}
			//PrintArr($arr_urls, "Urlnum: $urlnum ");
		//}
		$restofline=substr($line, $dashloc+3);
		$arr_restofline=explode(" +++", $restofline);
		
		//Datimestamp
		$thisdatimestamptext=$arr_restofline[0];
		$thisdatetimestamp=strtotime($thisdatimestamptext);
		
		if ($dup_url_found)
		{	$tempurlsetnum=$key+1;
			$tempurlnum=$key;
			//$urlset_dup_timestamps[$
		}
		else
		if (!$dup_url_found)
		{
			$urlset_timestamps[$urlsetnum]=$thisdatetimestamp;
			$urlset_dates[$urlsetnum]=$thisdatimestamptext;
		
		//Scraped web title
			$this_scrapedwebtitle=$arr_restofline[1];
			$this_scrapedwebtitle=trim($this_scrapedwebtitle);
			$urlset_scrapedwebtitles[$urlsetnum]=$this_scrapedwebtitle;
			
		};
		
		//Shortdesc (if any)
		$this_shortdesc=$arr_restofline[2];
		$this_shortdesc=trim($this_shortdesc);
	
		if ($dup_url_found)
		{	if ($this_shortdesc)
			{
		//	echo "Temp nums: $tempurlsetnum $tempurlnum ";
				$urlset_shortdescs[$tempurlsetnum][$tempurlnum] .= ";$this_shortdesc";
		//	echo "<pre>";
			}
			if ($thisdatimestamptext)
			{	$urlset_dates[$tempurlsetnum] .= "*_splituphere_*$thisdatimestamptext";
				//echo $urlset_dates[$tempurlsetnum];
			}
			
		//	PrintArr($urlset_shortdescs);
			$urlnum--;
			$urlsetnum--;
		}
		else
		{
			$urlset_shortdescs[$urlsetnum][$urlnum].=$this_shortdesc;
		}
		
		$linenum++;
	}
}

if ($inputformat=="original")
{
	$urlnums_to_skip=array();
	$added_urls=array();
	foreach ($arr_urls as $line)
	{	$key=false;
		$dup_url_found=false;
		
		//URL
		
		$len=strlen($line);
	//|| $len<8
		if (BackslashesDetectedIn($line) || ColonEtcAbsentIn($line) )
		{	//if it's definitely not a URL, we check to see if it's a date.
			$unusedlines[$linenum]=$line;

			//Need something to detect if the line contains numbers. If it doesn't,
			//don't even bother with the timestamp check, just set it to false.
			$numshere=preg_match("/[0-9]/", $line);
			
			if ($numshere)
			{	
				if ($remove_commas_from_dates_before_periods)
				{	$line=str_replace(",", " ", $line);
				}
				
				$timestamp = strtotime($line);
				$nowdate = date("Y-m-d H:i:s", $timestamp);
			}
			else
			{	$timestamp=false;
			}
			
			if ($timestamp === false)
			{	//no date here, so we can use this as shortdesc line.

				$urlset_shortdescs[$urlsetnum][$urlnum] .= "$line\r\n";
			}
			else	//There's a date here.
			{	
				if ($curtimestamp)
				{	if ($timestamp!=$curtimestamp)
					{	$urlsetnum++;
						$urlset_urls[$urlsetnum]=array();
						$urlnum=-1;
					}
				}
				
				$urlset_timestamps[$urlsetnum]=$timestamp;
				$urlset_dates[$urlsetnum]=$line;
				$curtimestamp=$timestamp;
			}
			unset($arr_urls[$linenum]);
			
			$unusednum++;
		}
		else	//We're dealing with a URL...
		{	$urlnum++;
		
			//Should add some code to look for duplicates in $arr_urls...
			//Like, if the person put the same URL multiple times in their input.
			
			$key=array_search($line, $added_urls);
			if ($key!==false)
			{	$dup_url_found=true;
				//echo "Key: $key ";
				$numofdups++;
				array_push($urlnums_to_skip, $key);
				$dupurls[$numofdups]=$line;
				$urlnum--;
				
			}
			if (!$dup_url_found)
			{	
				$urlset_urls[$urlsetnum][$urlnum]=$line;
				#echo " Urlset num: $urlsetnum  Urlnum: $urlnum ";
				
				#PrintArr($urlset_shortdescs);
				if ( !isset( $urlset_shortdescs[$urlsetnum][$urlnum] ) )
				{
					$urlset_shortdescs[$urlsetnum][$urlnum] = "";
				}
				array_push($added_urls, $line);
				if (!isset( $urlset_timestamps[$urlsetnum] ) )
				{
				
					$nowtimestamp=time();
					$nowdate = date("Y-m-d H:i:s", $nowtimestamp);
					$urlset_timestamps[$urlsetnum]=$nowtimestamp;
					
					$urlset_dates[$urlsetnum]=$nowdate;
					$curtimestamp=$nowtimestamp;
				}
			}
			
		}
		$linenum++;
	}

}

$x=0;

foreach($urlset_urls as $urls)
{	
	if (!$urls)
	{	
		$reassign_keys=true;
		unset($urlset_urls[$x]);
		unset($urlset_dates[$x]);
		unset($urlset_timestamps[$x]);
		unset($urlset_shortdescs[$x]);
		$urlsetnum--;
	}
	$x++;
}


if ($reassign_keys)
{	
	$urlset_urls=array_merge($urlset_urls);
	$urlset_dates=array_merge($urlset_dates);
	$urlset_timestamps=array_merge($urlset_timestamps);
	$urlset_shortdescs=array_merge($urlset_shortdescs);
}
if ($revinputorder)
{	if ($inputformat=="urlhistory_apmod")
	{	GoBackToFormWithError("can't reverse input order with urlhistory apmod");
		exit;
	}
//	echo "REV INPUT ORDER";
	$arr_urls=array_reverse($arr_urls);
	
	$urlset_urls=array_reverse($urlset_urls);
	$urlset_dates=array_reverse($urlset_dates);
	$urlset_timestamps=array_reverse($urlset_timestamps);
	$urlset_shortdescs=array_reverse($urlset_shortdescs);
}

	//Well, mostly... but, have to do extra checking to filter out duplicate URLs, sigh...
if (!$arr_urls)
{	GoBackToFormWithError("no urls");
	exit;
}

$display_name_of_url_db_being_used=ucwords($url_db_to_use);

echo "<html><head><title>ABDesktop Multiple URL Adder Results - DB: $display_name_of_url_db_being_used</title>
<link rel=stylesheet href=\"css/l.css\" type=\"text/css\">
<style type=\"text/css\"> 
</style><body><center>";
AllOrganizerNavLinks();
echo "<h1>ABDesktop Multiple URL Adder Results</h1>
<p>";
PrintDBHeader("url");
echo "<p>
<a href=\"$webpath_of__abdesktop/urls/multi_url_adder_form.php?db=$url_db_to_use\" class='arial_link'>Add More</a></center>";

echo "<div id='maintext'><pre>";

$arr_urls=array_merge($arr_urls);
$query_to_issue="SELECT url, url_id, earliest_col_date from urlinfo WHERE ( ";


$z=0;
foreach ($arr_urls as $url)
{
	$cleanurl = MakeRawUrlClean($url);
	$arr_urls[$z] = $cleanurl;
	
	$query_to_issue .= "url = '$cleanurl' OR ";
	$z++;
}
$query_to_issue = substr($query_to_issue, 0, -4);
$query_to_issue .= ") ORDER BY url_id ASC";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

$y=0;
if (mysql_num_rows($query_result) > 0)
{	$urlexists="true";
	while ($info = mysql_fetch_array($query_result) )
	{	$url=$info['url'];
		$cleanurl = MakeRawUrlClean($url);
		$thisid=$info['url_id'];

		$existing_urlids[$y]=$thisid;
		$existing_urls[$y]=$url;
		$existing_coldates[$thisid]=$info['earliest_col_date'];
		$y++;
	}
	array_merge($existing_urls);
}


$query_to_issue="INSERT INTO urlinfo (protocol, hostname, suffix, path, dirsonly, fullfilename, filenameonly, filext, allparams, anchor, username, password, port, numofdots, isdynamicurl, url, repository, forsite, whenadded, earliest_col_date, shortdesc, scrapedwebtitle) VALUES\n";

$sourcenotesquery="INSERT INTO urlsourcenotes (url_id, sourcenotes) VALUES ";

$shortdesc=EncloseOrNull($shortdesc, "'");
$sourcenotes=EncloseOrNull($sourcenotes, "'");

$all_inserturls=array();
$insert_urls=array();
$insertedurls=0;
if ($inputformat=="original")
{ 	$x=0;
}
else
{
	$x=1;
}
$absolute_num_of_inserted_urls=0;

//PrintArr($urlset_urls);
//exit;
$urlnum=-1;

while ($x<=$urlsetnum)
{	$z=0;
	$urlnum++;
	if ($inputformat=="urlhistory_apmod")
	{	$z=$urlnum;
	}
	if ($revinputorder)
	{
		$urlset_urls[$x]=array_reverse($urlset_urls[$x]);
		if (is_array($urlset_dates[$x]) )
		{
			$urlset_dates[$x]=array_reverse($urlset_dates[$x]);
		}
		if (is_array($urlset_timestamps[$x]) )
		{
			$urlset_timestamps[$x]=array_reverse($urlset_timestamps[$x]);
		}
		$urlset_shortdescs[$x]=array_reverse($urlset_shortdescs[$x]);
	}
	
//PrintArr($urlset_urls[$x]);
	foreach ($urlset_urls[$x] as $thiskey => $url)
	{	
		//$foundkey=false;
		//PrintArr($urlset_urls[$x]);
	//	if ($inputformat=="urlhistory_apmod")
	//	{	$foundkey=array_search($thiskey, $urlnums_to_skip);
	//		if ($foundkey!==false)
	//		{	echo "Found key: $foundkey ";
		//		continue;
	//		}
	//	}
		$cleanurl = MakeRawUrlClean($url);
		$clean_urlset_urls[$x][$z]=$cleanurl;
	//	echo "X: $x Z: $z ";
		$thisshortdesc=$urlset_shortdescs[$x][$z];
		if (isset ($urlset_scrapedwebtitles[$x] ) )
		{
			$thisscrapedwebtitle=$urlset_scrapedwebtitles[$x];
	//	echo "Thisshortdesc: $thisshortdesc ";
			$cleanscrapedwebtitle=$thisscrapedwebtitle;
		//echo "Clean: '$cleanscrapedwebtitle'<br>";
			CleanInput($cleanscrapedwebtitle);
			$clean_urlset_scrapedwebtitles[$cleanurl]=$cleanscrapedwebtitle;
		}
		$cleanshortdesc=$thisshortdesc;
		CleanInput($cleanshortdesc);
		//$cleanshortdesc=substr($cleanshortdesc, 0, -4);
		
		$clean_urlset_shortdescs[$cleanurl]=$cleanshortdesc;
		
		//echo "Clean: '$cleanscrapedwebtitle'<br>";
		$z++;
	}
	
	if ($existing_urls)
	{
		$insert_urls[$x]=array_idiff($clean_urlset_urls[$x], $existing_urls);
		$urlset_existing_urls[$x]=array_intersect($existing_urls, $clean_urlset_urls[$x]);

	}
	else
	{	$insert_urls[$x]=$clean_urlset_urls[$x];
	}
	$all_inserturls=array_merge($all_inserturls, $insert_urls[$x]);
	
	if (!$coldate_overrider)
	{	
		if ($inputformat=="original")
		{
			$rawdate[$x]=$urlset_dates[$x];
			$temptimestamp=MakeIntoUnixTime($rawdate[$x]);
			$cleandate[$x]=MakeRawDateClean($rawdate[$x]);
			$datetimestamp[$x]=date("Y-m-d H:i:s", $temptimestamp);
		}
		else if ($inputformat=="urlhistory_apmod")
		{
			$these_raw_dates=$urlset_dates[$x];
			$arr_these_raw_dates=explode("*_splituphere_*", $these_raw_dates);
			
			$numofdates=0;
			$prevtime=false;
					
			foreach ($arr_these_raw_dates as $thisrawdate)
			{
				$temptimestamp=MakeIntoUnixTime($thisrawdate);
				$cleandate[$x][$numofdates]=MakeRawDateClean($thisrawdate);
				$datetimestamp[$x][$numofdates]=date("Y-m-d H:i:s", $temptimestamp);
				$thistime=strtotime($datetimestamp[$x][$numofdates]);
				if (!$prevtime)
				{	$time_earliest_new_coldate[$x]=$thistime;
					$earliest_new_coldate[$x]=$datetimestamp[$x][$numofdates];
				//	echo "Earliest no prevtime: $time_earliest_new_coldate<br>";
				}
				else if ($prevtime)
				{	
					if ($thistime<$prevtime)
					{	$time_earliest_new_coldate[$x]=$thistime;
						$earliest_new_coldate[$x]=$datetimestamp[$x][$numofdates];
						//echo "Changing earliest prevtime";
					}
				}
				$prevtime=$thistime;
					
			//	$time_earliest_new_coldate[$x][$numofdates]=$thistime;
				
				$numofdates++;
			}
			
		}
	}
	else
	{	
		#echo "yay coldate overrider timestamp";
		
		$datetimestamp[$x]=$coldate_overrider_timestamp;
		$cleandate[$x]=$clean_coldate_overrider;
	}
	
	if ($insert_urls[$x])
	{	$execute_insert_query=true;
		$numofinsertedurls[$x]=0;
		
		foreach ($insert_urls[$x] as $cleanurl)
		{	$this_shortdesc=$clean_urlset_shortdescs[$cleanurl];
			if (!$this_shortdesc)
			{	$input_shortdesc=$shortdesc;
			}
			else
			{	$input_shortdesc=$this_shortdesc;
				$input_shortdesc=EncloseOrNull($input_shortdesc, "'");
			}
			$this_scrapedwebtitle=$clean_urlset_scrapedwebtitles[$cleanurl];
			$input_scrapedwebtitle=$this_scrapedwebtitle;
			$input_scrapedwebtitle=EncloseOrNull($input_scrapedwebtitle, "'");
			
			UnsetUrlDetails($x);
			GetUrlDetails($cleanurl, $x);
			
			if ($inputformat=="urlhistory_apmod")
			{	
				$thedatimestamp=$earliest_new_coldate[$x];
			}
			else
			{	$thedatimestamp=$datetimestamp[$x];
			}
			
			$query_to_issue .= "\n($protocol[$x], $hostname[$x], $suffix[$x], $path[$x], $dirsonly[$x], $fullfilename[$x], $filenameonly[$x], $filext[$x], $params[$x], $anchor[$x], $username[$x], $password[$x], $port[$x], $numofdots[$x], $dynamicurlornot[$x], '$cleanurl', 'y', 'unspecified', now(), '$thedatimestamp', $input_shortdesc, $input_scrapedwebtitle), \n";
			
			$numofinsertedurls[$x]++;
			$absolute_num_of_inserted_urls++;
		}
	}
	$x++;
}


echo "Number of inserted urls: $absolute_num_of_inserted_urls ";

echo "<b>";
PrintArr($all_inserturls, "Inserted URLs:");
echo "</b>";
if ($dupurls)
{	PrintArr($dupurls, "Duplicate URLs found in your input:");
}
if ($existing_urls)
{
	PrintArr($existing_urls, "Existing thus excluded URLs:");
}
if ($unusedlines)
{
	PrintArr($unusedlines, "Other lines:");
}
if ($clean_urlset_shortdescs)
{
	PrintArr($clean_urlset_shortdescs, "Shortdescs:");
}
if ($clean_urlset_scrapedwebtitles && $inputformat=="urlhistory_apmod")
{
	PrintArr($clean_urlset_scrapedwebtitles, "Scraped web titles:");
}


echo "<p><br>";

$coldatequery="INSERT INTO urldatesofcollection (url_id, timestamp, orig_datestring) VALUES \n";

if ($execute_insert_query)
{
	$query_to_issue = substr($query_to_issue, 0, -3);
	
	echo "<p><b>Query:</b> $query_to_issue<p>";
	
	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
	
	$addedurl_id = mysql_insert_id();
	
	echo "<p><b>ID of first inserted URL:</b> $addedurl_id<p>";
	
	$x=0;
	while ($x<$absolute_num_of_inserted_urls)
	{	$thisid=$addedurl_id+$x;
		$sourcenotesquery .= "\n($thisid, $sourcenotes), \n";
		$x++;
	}
	$sourcenotesquery = substr($sourcenotesquery, 0, -3);
	echo "<p><br><b>Source notes query:</b> $sourcenotesquery<p>";
	$query_result=mysql_query($sourcenotesquery,$handle) or die(mysql_error());

	$x=0;
	while ($x<$absolute_num_of_inserted_urls)
	{	$thisid=$addedurl_id+$x;
		$altqueries .= "\n($thisid, NULL), \n";
		$x++;
	}
	$othernotesquery="INSERT INTO urlothernotes (url_id, othernotes) VALUES " . $altqueries;
	$othernotesquery = substr($othernotesquery, 0, -3);
	echo "<p><b>Othernotes query</b>: $othernotesquery<P>";
	$query_result=mysql_query($othernotesquery,$handle) or die(mysql_error());
	
	$longdescquery="INSERT INTO urllongdesc (url_id, longdesc) VALUES " . $altqueries;
	$longdescquery = substr($longdescquery, 0, -3);
	echo "<p><b>Longdesc query:</b> $longdescquery<p>";
	$query_result=mysql_query($longdescquery,$handle) or die(mysql_error());

	$x=0;
	$z=0;

	if ($inputformat=="original")
	{
		while ($x<=$urlsetnum)
		{	
			$z=0;
			while ($z<$numofinsertedurls[$x])
			{	
				$coldatequery .= "\n('$addedurl_id', '$datetimestamp[$x]', '$cleandate[$x]'), \n";
				$addedurl_id++;
				$z++;
			}
			$x++;
		}
	}
	else if ($inputformat=="urlhistory_apmod")
	{	while ($x<=$urlsetnum)
		{	
			$z=0;
			while ($z<$numofinsertedurls[$x])
			{	foreach ($datetimestamp[$x] as $key => $thistimestamp)
				{	$thisdate=$cleandate[$x][$key];
					//$querybit.="\n('$thisurlid', '$thistimestamp', '$thisdate'), \n";
					$coldatequery .= "\n('$addedurl_id', '$thistimestamp', '$thisdate'), \n";
					//	echo "ARGH $x $querybit  zargh<br>";
				}
				//$coldatequery .= "\n('$addedurl_id', '$datetimestamp[$x]', '$cleandate[$x]'), \n";
				$addedurl_id++;
				$z++;
			}
			$x++;
		}
	}
}

if ($existing_urlids)
{
	if ($inputformat=="original")
	{	$x=0;
	}
	else
	{	$x=1;
	}
	if ($coldate_overrider)
	{	$time_new_coldate=$coldate_overrider_time;
	}
	if ($inputformat=="urlhistory_apmod")
	{	while ($x<=$urlsetnum)
		{	//$prevtime=false;
			if (!$coldate_overrider)
			{	foreach ($datetimestamp[$x] as $key => $thistimestamp)
				{//	echo "bark yeah $key $thistimestamp<br>";
					
					$thistime=strtotime($thistimestamp);
					$arr_time_new_coldate[$key]=$thistime;
					
					/*if (!$prevtime)
					{	$time_earliest_new_coldate=$thistime;
						$earliest_new_coldate=$thistimestamp;
						echo "Earliest no prevtime: $time_earliest_new_coldate<br>";
					}
					else if ($prevtime)
					{	
						if ($thistime<$prevtime)
						{	$time_earliest_new_coldate=$thistime;
							$earliest_new_coldate=$thistimestamp;
							echo "Changing earliest prevtime";
						}
					}*/
					
				//	$prevtime=$thistime;
					
					//$time_new_coldate=strtotime($datetimestamp[$x]);
				}
			}
			
			$w=0;
			
			unset($updateids);
			foreach ($urlset_existing_urls[$x] as $thisurl)
			{	$querybit = "";
				//echo "<p><br>Start of url loop<br>";
				$urlloc=array_search($thisurl, $existing_urls);
				
				$thisurlid=$existing_urlids[$urlloc];

				if ($coldate_overrider)
				{	$inputtimestamp=$coldate_overrider_timestamp;
					$inputcleandate=$clean_coldate_overrider;
					$querybit="\n('$thisurlid', '$inputtimestamp', '$inputcleandate'), \n";
				}
				else
				{	
					foreach ($datetimestamp[$x] as $key => $thistimestamp)
					{	$thisdate=$cleandate[$x][$key];
						$querybit.="\n('$thisurlid', '$thistimestamp', '$thisdate'), \n";
						
					//	echo "ARGH $x $querybit zargh<br>";
					}
				}
				
				$coldatequery .= $querybit;
			//	echo "<hr>BARG $coldatequery zarghme<br>";
				$this_orig_coldate=$existing_coldates[$thisurlid];
				$time_orig_coldate=strtotime($this_orig_coldate);
			//	echo "Timeorigcoldate: $time_orig_coldate<br>";
				if ($time_earliest_new_coldate[$x] && $time_earliest_new_coldate[$x]<$time_orig_coldate)
				{	$updateids[$w]=$thisurlid;
					//echo "ARRRGHHHH";
					$w++;
				}
				
			}
			if ($updateids)
			{	$numofids=count($updateids);
				$sqlids=implode(", ", $updateids);
				if ($coldate_overrider)
				{	$inputtimestamp=$coldate_overrider_timestamp;
				}
				else
				{	$inputtimestamp=$earliest_new_coldate[$x];
				}
				
				$query2="UPDATE urlinfo set earliest_col_date='$inputtimestamp' where url_id in ($sqlids) LIMIT $numofids";
				echo "<p><br><b>Updating earliest collection date:</b><p>$query2";
				mysql_query($query2,$handle);
			}
			$x++;
		}
		
	}
	else if ($inputformat=="original")
	{
		while ($x<=$urlsetnum)
		{
			if (!$coldate_overrider)
			{
				$time_new_coldate=strtotime($datetimestamp[$x]);
			}
			
			$w=0;
			
			unset($updateids);
			foreach ($urlset_existing_urls[$x] as $thisurl)
			{	
				$urlloc=array_search($thisurl, $existing_urls);
				
				$thisurlid=$existing_urlids[$urlloc];

				if ($coldate_overrider)
				{	$datetimestamp[$x]=$coldate_overrider_timestamp;
					$cleandate[$x]=$clean_coldate_overrider;
				}
				$querybit="\n('$thisurlid', '$datetimestamp[$x]', '$cleandate[$x]'), \n";
				$coldatequery .= $querybit;
				
				$thiscoldate=$existing_coldates[$thisurlid];
				
				$time_orig_coldate=strtotime($thiscoldate);
				
				if ($time_new_coldate && $time_new_coldate<$time_orig_coldate)
				{	$updateids[$w]=$thisurlid;
					$w++;
				}
			}
			if ( isset( $updateids ) )
			{	$numofids=count($updateids);
				$sqlids=implode(", ", $updateids);
				if ($coldate_overrider)
				{	$datetimestamp[$x]=$coldate_overrider_timestamp;
				}
				
				$query2="UPDATE urlinfo set earliest_col_date='$datetimestamp[$x]' where url_id in ($sqlids) LIMIT $numofids";
				echo "<p><br><b>Updating earliest collection date:</b><p>$query2";
				mysql_query($query2,$handle);
			}
			$x++;
		}
	}
}
	//echo "DARN $coldatequery";
	
		$coldatequery = substr($coldatequery, 0, -3);
		
		echo "<p><br><b>Date query:</b> $coldatequery ";
		
		mysql_query($coldatequery,$handle);
		$errormessage=mysql_error();

		echo "</pre><p><center>";
		if ($errormessage)
		{	EchoError("Error: $errormessage");
		}
		
echo "<p><a href=\"$webpath_of__abdesktop/urls/multi_url_adder_form.php?db=$url_db_to_use\" class='arial_link'>Add More</a>";

echo "<p><br><br>";

AllOrganizerNavLinks();
echo "</body></html>";
