<?php

class ExportQueryObject
{
	public $array_of_middle_parts=array();
	public $num_of_middle_parts;
	public $first_part;
	public $final_query;
	
	public function __construct($firstpart)
	{
		$this->first_part=$firstpart;
	
	}
	public function Add($querybit)
	{
		array_push($this->array_of_middle_parts, $querybit);
		$this->num_of_middle_parts++;
	}
	public function Construct()
	{
		$res=$this->first_part;
		$res.="	";
		$middleparts=implode(", \n	", $this->array_of_middle_parts);
		$res .= $middleparts;
		
	//	$res .= $lastpart;
		$this->final_query=$res;
		#echo $this->final_query;
		return $this->final_query;
	}
	public function __toString()
	{
		return $this->Construct();
	}

}


class DatabaseObject
{
	public $name;
	public $version;
	public $handle;
	
	protected $result_of_show_columns_from_fileinfo;
	protected $result_of_show_columns_from_imageinfo;
	
	protected $array_of_db_tables=array();
	
	public $array_of_all_filerecord_fields=array();
	public $string_of_all_filerecord_fields;
	
	public $array_of_only_fileinfo_fields=array();	
	public $string_of_only_fileinfo_fields;
	
	public $array_of_only_file_sha512_hashes_fields = array();
	public $string_of_only_file_sha512_hashes_fields;
	
	public $array_of_only_imageinfo_fields=array();
	public $string_of_only_imageinfo_fields;
	
	public function __construct($file_db_to_use, $handle)
	{
		#echo "<p>Making DB object... $file_db_to_use<p>";
		
		$this->handle=$handle;
		$this->name = $file_db_to_use;
	
		$this->GetColumnsFrom("fileinfo");
		$this->GetColumnsFrom("imageinfo");
		$this->GetColumnsFrom("file_sha512_hashes", "exclude from array of all filerecord fields");
	
	#	echo "am here";
		//PrintArr($this->result_of_show_columns_from_fileinfo);
		//PrintArr($this->result_of_show_columns_from_imageinfo);
		
		//PrintArr($this->array_of_all_filerecord_fields, "array_of_all_filerecord_fields");
		//PrintArr($this->array_of_only_fileinfo_fields, "array_of_only_fileinfo_fields");
	//	PrintArr($this->array_of_only_imageinfo_fields, "array_of_only_imageinfo_fields");
	//echo "<p>string_of_all_filerecord_fields: $string_of_all_filerecord_fields";
		
		$table_list_query_to_issue = "SHOW TABLES FROM $file_db_to_use";
	//	echo "table_list_query_to_issue $table_list_query_to_issue<p>";
		$table_list_query_result = mysql_query($table_list_query_to_issue,$handle) or die(mysql_error());
		
		$x=0;
		while ($row = mysql_fetch_row($table_list_query_result)) 
		{	$table_list[$x]=$row[0];
			$x++;
		}
		
		$this->array_of_db_tables=$table_list;
		
		#print_r($table_list);
		
		if (in_array("db_version_history", $table_list) )
		{
			$version_query_to_issue="SELECT version from db_version_history ORDER BY when_updated DESC limit 1 ";
			$version_query_result = mysql_query($version_query_to_issue,$handle) or die(mysql_error());
		
			$version_info=mysql_fetch_array($version_query_result);
			$this->version=$version_info["version"];
		}
		else
		{
			$this->version="Pre-ABDesktop 2.0";
		}
		
	#	echo "down here";
		
	//	echo "<br>DB name: " . $this->name;
	//	echo "<br>Version: " . $this->version;
		
	}
	public function GetColumnsFrom($table, $should_exclude_from_array_of_all_filerecord_fields = false )
	{
		$fieldstring="";
		
		$columns_query_to_issue="SHOW COLUMNS FROM $table";
		$columns_query_result=mysql_query($columns_query_to_issue,$this->handle) or die(mysql_error());
		#echo "<pre>";
	#print_r( debug_backtrace() );
		
		#echo " Now in GetColumnsFrom()";
		
		#echo " $table";
		
		if (mysql_num_rows($columns_query_result) > 0) 
		{	$x=0;
			$result_array="result_of_show_columns_from_" . $table;
			
			while ($row = mysql_fetch_assoc($columns_query_result)) 
			{	$this->{$result_array}[$x]=$row;
				$fieldstring .= "$table." . $row['Field'] . ", ";
				$x++;
			//	print_r($row);
			}
			//echo "Fieldstring: $fieldstring";
			$fieldstring=TrimComma($fieldstring);
			//echo "<p>Fieldstring: $fieldstring";
			
			$string_of_only_tablex_fields="string_of_only_$table" . "_fields";
			$array_of_only_tablex_fields="array_of_only_$table" . "_fields";
			
			$this->{$array_of_only_tablex_fields} = explode(", ", $fieldstring);
			sort($this->{$array_of_only_tablex_fields}, SORT_STRING);
			
			//$this->{$string_of_only_tablex_fields} = $fieldstring;
			
			$this->{$string_of_only_tablex_fields} = implode(", ", $this->{$array_of_only_tablex_fields} );
			
			
			
		#	PrintArr($this->{$array_of_only_tablex_fields}, "$array_of_only_tablex_fields in getcolumns");
			
			//PrintArr($this->array_of_all_filerecord_fields, "array_of_all_filerecord_fields in getcolumns ");
			
			if ( !$should_exclude_from_array_of_all_filerecord_fields)
			{
				$this->array_of_all_filerecord_fields = array_merge($this->array_of_all_filerecord_fields, $this->{$array_of_only_tablex_fields} );
			
				sort($this->array_of_all_filerecord_fields, SORT_STRING);
			
			//PrintArr($this->array_of_all_filerecord_fields, "array_of_all_filerecord_fields in getcolumns after add");
			
				$this->string_of_all_filerecord_fields = implode(", ", $this->array_of_all_filerecord_fields);
			}
		/*	if (strlen($this->string_of_all_filerecord_fields) )
			{
				$this->string_of_all_filerecord_fields = $this->string_of_all_filerecord_fields . ", " . $this->{$string_of_only_tablex_fields};
			}
			else
			{
				$this->string_of_all_filerecord_fields = $this->{$string_of_only_tablex_fields};
			}*/
			
		}
	}
	public function ImageFieldsCompatibleWith($other_db)
	{
		if ($this->string_of_only_imageinfo_fields != $other_db->string_of_only_imageinfo_fields)
		{
			return "different imageinfo fields";
		}
		return true;
	}
	public function CompatibleWith($other_db)
	{
		/*if ($this->result_of_show_columns_from_fileinfo != $other_db->result_of_show_columns_from_fileinfo)
		{
			return "different result of show columns from fileinfo";
		}*/
	
	
		if ($this->version != $other_db->version)
		{	echo "Uh-oh, diff version";
			return "different version";
		}
		else if ($this->string_of_only_fileinfo_fields != $other_db->string_of_only_fileinfo_fields)
		{	echo "uh-oh, diff fileinfo fields<br>" . "<table border><tr><th>" . $this->name . "<th>" . $other_db->name . "<tr><td>" . strlen($this->string_of_only_fileinfo_fields) . "<td>" . strlen($other_db->string_of_only_fileinfo_fields ) . "<tr><td>" . $this->string_of_only_fileinfo_fields . "<td>" . $other_db->string_of_only_fileinfo_fields . "</table>" ;
			
			return "different fileinfo fields";
		}
		else if ($this->string_of_only_imageinfo_fields != $other_db->string_of_only_imageinfo_fields)
		{	echo "uh-oh, diff imageinfo fields";
			return "different imageinfo fields";
		}
		else if ($this->string_of_only_file_sha512_hashes_fields != $other_db->string_of_only_file_sha512_hashes_fields)
		{	echo "uh-oh, diff file_sha512_hashes fields";
			return "different file_sha512_hashes fields";
		}
		
		return true;
	}
}

class ReceivingDatabase extends DatabaseObject
{
	//public $array_of_fields_to_exclude_from_verififcation = array("fileinfo.file_id", "fileinfo.whenexported"
	public $array_of_file_ids_of_received_records_which_didnt_match_orig_records=array();
	
	public $array_of_file_ids_of_records_to_receive_image_details=array();
	
	public function Add_To_List_Of_Records_To_Receive_Image_Details($id)
	{
		array_push($this->array_of_file_ids_of_records_to_receive_image_details, $id);
		
	}
}

class SendingDatabase extends DatabaseObject
{
	
	public $array_of_fields_to_exclude_from_export = array("fileinfo.file_id");
	
	public $array_of_only_fileinfo_fields_for_export;
	public $string_of_only_fileinfo_fields_for_export;
	
	public $datime_of_export;
	public $number_of_records_for_export=0;
	
	public $array_of_file_ids_of_exported_images=array();
	public $array_of_file_ids_of_exported_records_with_tags=array();
	public $array_of_file_ids_of_exported_records_with_sha512_hashes = array();
	
	
	public $array_of_file_ids_of_exported_records=array();
	
	public $hash_of_paired_file_ids_and_paired_dir_names=array();
	public $hash_of_orig_file_ids_and_new_file_ids=array();	
	public $hash_of_new_file_ids_and_orig_file_ids=array();

	public function __construct($file_db_to_use, $handle)
	//$filerecords)
	{	
		parent::__construct($file_db_to_use, $handle);
		
		
		$arr=array_diff($this->array_of_only_fileinfo_fields, $this->array_of_fields_to_exclude_from_export);
		
		$this->array_of_only_fileinfo_fields_for_export=$arr;
		$this->string_of_only_fileinfo_fields_for_export=implode(", ", $arr);
		
		$this->datime_of_export=GetNowTimestamp();
	//	echo "sendingdbobject worked!" . $this->datime_of_export;
		
	}
	public function Add_To_List_Of_Exported_Records($id)
	{	#echo "ID: $id " . $this->name;
		array_push($this->array_of_file_ids_of_exported_records, $id);
	//	PrintArr($this->array_of_file_ids_of_exported_records);
		$this->number_of_records_for_export++;
	}
	public function Sort_List_Of_Exported_Records()
	{	sort($this->array_of_file_ids_of_exported_records, SORT_NUMERIC);
		//PrintArr($this->array_of_file_ids_of_exported_records);
	}
	public function Add_To_Hash_Of_Paired_File_IDs_and_Paired_Dir_Names($id, $filename)
	{
		//echo "ID: $id, Filename: $filename";
		$this->hash_of_paired_file_ids_and_paired_dir_names[$id]=$filename;
	}	
}


class FileRecordForVerification extends ArrayObject
{
	public $Original_Record;
	public $array_of_fields_which_dont_match=array();
	public $string_of_fields_which_dont_match;
	
	public function __construct($array, &$db_containing_this_record=0)
	{
		parent::__construct($array,ArrayObject::ARRAY_AS_PROPS);
		
		//PrintArr($array);
		//echo "</pre>";
		
		$this->db=$db_containing_this_record;
		
		
		
		$prevdb_file_id="fileinfo.prevdb_file_id";
		$filename="fileinfo.filename";
		
		$original_record="ExportedFileRecord" . $this->{$prevdb_file_id};
		global ${$original_record};
		$this->Original_Record=${$original_record};
		
		//$this->Original_Record->{$filename}="argh";
		
		//echo "<p>this->Original_Record->filename: " . $this->Original_Record->{$filename} . "<p>";
		
	//	echo "orig record filename: " . ${$original_record}->{$filename} . "<p>";
		
	#	echo "Orig rec filename: " . $this->Original_Record->{$filename};
	//	echo "<pre>";
	//	print_r ($this);
	//	echo "</pre>";
	}
	public function Verify()
	{	//echo "Borkborkbork";
		// 7:52:07 7/12/2012. This ought to be made to check that the thumbnail exists, if it's an image.
		$file_id="fileinfo.file_id";
		foreach($this->db->array_of_all_filerecord_fields as $field)
		{
			if ($field=="fileinfo.file_id" || $field=="imageinfo.file_id")
			{
				continue;
			}
			else if ($field=="fileinfo.prevdb_file_id")
			{	#echo "Prevdbid: " . $this->{$field} . " - " . $this->Original_Record->{$file_id};
			
				if ($this->{$field} == $this->Original_Record->{$file_id} )
				{
					#echo "Original file ID same as prev db file id";
					continue;
				}
			}
			else if ($field=="fileinfo.mostrecentprevdb")
			{	//echo "<p>this->Original_Record->db->name: " . $this->Original_Record->db->name;
				//echo "<p>this->$field " . $this->{$field};
				if ($this->{$field} == $this->Original_Record->db->name ) 
				{
					#echo "<p>mostrecentprevdb matches original record db name";
					continue;
				}
			}
			else if ($field=="fileinfo.whenexported")
			{
				if ($this->{$field} == $this->Original_Record->db->datime_of_export)
				{
				#	echo "<p>whenexported matches db datime_of_export<p>";
					continue;
				}
			}
			
			
			if ($this->{$field} != $this->Original_Record->{$field})
			{
			
				if ($field=="fileinfo.forsite")
				{	#echo "ARGH forsite value: " . $this->{$field} . " --";
					
					if ($this->{$field} == "unspecified" && $this->Original_Record->{$field}===null)
					{	#echo "  forsite!"; 
						continue;
					}
				}
			
				echo "Uh-oh!  $field not matched! ";
				echo "<p>";
				echo "Verif field: " . $this->{$field};
				p();
				echo "Orig field: " .  $this->Original_Record->{$field};
				
				array_push($this->array_of_fields_which_dont_match, $field);
			}
			
		}
		
		#PrintArr($this->array_of_fields_which_dont_match, "Array of fields which don't match");
	#	echo "count " . count ($this->array_of_fields_which_dont_match);
		$this_darn_array=$this->array_of_fields_which_dont_match;
		
	//	if ( !empty($this->array_of_fields_which_dont_match) )
		if (!empty($this_darn_array) )
		{	#echo "am returning false";
			return false;
		}
		else if (empty($this_darn_array) )
	//	else if (empty($this->array_of_fields_which_dont_match) )
		{	#echo "am returning true";
			return true;
		}
		
	}
}


class FileRecordProvidingShaDetails extends ArrayObject
{
	public function __construct($array, &$db_containing_this_record=0)
	{
		parent::__construct($array,ArrayObject::ARRAY_AS_PROPS);
		$this->db=$db_containing_this_record;
	}
	
	public function ShaQueryData($fields_needed, $new_file_id)
	{
		$res = "(";
		
		foreach ($fields_needed as $field)
		{
			${$field}=$this->{$field};
		//	echo "<br>This image field: $field " . $this->{$field};
			if ($field=="file_sha512_hashes.file_id")
			{
				${$field}=$new_file_id;
			}
			
			$cleanfield = ${$field};
			CleanInput($cleanfield);
			
			$enclosedfield=EncloseOrNull($cleanfield, "'");
			//$res .= "$field = $enclosedfield, ";
			$res .= "$enclosedfield, ";
		}
		$res=TrimComma($res);
		$res .= ")";
		//	echo "Res: $res";
		return $res;
	}
	
}

class FileRecordProvidingImageDetails extends ArrayObject
{
	public function __construct($array, &$db_containing_this_record=0)
	{
		parent::__construct($array,ArrayObject::ARRAY_AS_PROPS);
		$this->db=$db_containing_this_record;
	}
	
	public function ImageinfoQueryData($fields_needed, $new_file_id)
	{
		$res = "(";
		
		foreach ($fields_needed as $field)
		{
			${$field}=$this->{$field};
		//	echo "<br>This image field: $field " . $this->{$field};
			if ($field=="imageinfo.file_id")
			{
				${$field}=$new_file_id;
			}
			
			$cleanfield = ${$field};
			CleanInput($cleanfield);
			
			$enclosedfield=EncloseOrNull($cleanfield, "'");
			//$res .= "$field = $enclosedfield, ";
			$res .= "$enclosedfield, ";
		}
		$res=TrimComma($res);
		$res .= ")";
		//	echo "Res: $res";
		return $res;
	}
	
}

class FileRecordNeedingPrevDbImageDetails extends ArrayObject
{
	public $db;
	public $file_id;
	public $prevdb_file_id;
	public $mostrecentprevdb;
	public $extcat;
	
	//public function __construct($file_id, $prevdb_file_id, $mostrecentprevdb, $extcat)
	public function __construct($array, &$db_containing_this_record=0)
	{
	/*	$this->file_id=$file_id;
		$this->prevdb_file_id=$prevdb_file_id;
		$this->mostrecentprevdb=$mostrecentprevdb;
		$this->extcat=$extcat;*/
		
		parent::__construct($array,ArrayObject::ARRAY_AS_PROPS);
		$this->db=$db_containing_this_record;
		
		
		
	}
}

class FileRecordForExport extends ArrayObject
{
	public $db;
	public $datime_of_export;	// will be used as new value for when_exported field.
	public $new_file_id;
	public $orig_thumbnail_path;
	public $new_thumbnail_path;
	public $tagtypes_with_tags=array();
	//public $property_array=array();
	
	public function __construct($array, &$db_containing_this_record=0)
	{
		parent::__construct($array,ArrayObject::ARRAY_AS_PROPS);
		$this->db=$db_containing_this_record;
		
		//$this->property_array=$array;
		
		$file_id="fileinfo.file_id";
		$extcat="fileinfo.extcat";
		$sha512_hash="fileinfo.sha512_hash";
		
		if ($this->{$extcat}=="Image")
		{	
			$this->orig_thumbnail_path=GetThumbnailPath($this->{$file_id} );
		}
		if ($this->{$extcat}=="Icon")
		{
			$this->orig_thumbnail_path=GetThumbnailPath($this->{$file_id}, false, true);
		}
		
		if ( $this->{$sha512_hash} )
		{
			array_push ($db_containing_this_record->array_of_file_ids_of_exported_records_with_sha512_hashes, $this->{$file_id} );
		}
		
		//array_of_file_ids_of_exported_records_with_tags
		global $tagstring_list, $arr_needed_tagstrings, $changed_tagtypes;;
		//arr_needed_tagstrings
		foreach ($tagstring_list as $tagstring_property => $tagtype)
		{	#echo "yikes";
			if ($this->{$tagstring_property}!==null)
			{
				#echo "Found a valid tagstring! " . $this->{$tagstring_property} . " $tagtype !<br>";
			//	array_push($arr_needed_tagstrings, $tagstring_property);
				array_push($this->tagtypes_with_tags, $tagtype);
				//array_push($changed_tagtypes, $tagstring);
				array_push($db_containing_this_record->array_of_file_ids_of_exported_records_with_tags, $this->{$file_id} );
				
				//$this->{$tagstring_property}=CleanUptagstring( $this->{$tagstring_property} );
				
				//${$ExportedFileRecordX}->$tagstring_property=CleanUptagstring (${$ExportedFileRecordX}->$tagstring_property );
				
			}
		}
		$db_containing_this_record->array_of_file_ids_of_exported_records_with_tags = array_unique($db_containing_this_record->array_of_file_ids_of_exported_records_with_tags);
		
		
		//echo $this->db->datime_of_export;
		
		//$test=$this->db->datime_of_export;
	//	echo "TEst: $test";
		//print_r($this);
	//	$this->datime_of_export=$datime_of_export;
	}
	public function CopyThumbnail()
	{	$extcat="fileinfo.extcat";
		if ($this->{$extcat}=="Image")
		{	
			$new_thumbnail_path=GetThumbnailPath($this->new_file_id);
			//$this->orig_thumbnail_path=GetThumbnailPath($this->{$file_id} );
		}
		if ($this->{$extcat}=="Icon")
		{	$new_thumbnail_path=GetThumbnailPath($this->new_file_id, false, true);
		}
		//$new_thumbnail_path=GetThumbnailPath($this->new_file_id);
		$this->new_thumbnail_path=$new_thumbnail_path;
		//echo "<p>New thumbnail path: $new_thumbnail_path Orig thumbnail path: " . $this->orig_thumbnail_path;
		copy($this->orig_thumbnail_path, $new_thumbnail_path);
	} //http://localhost/l/abdesk-data/tn/testfiles2-temp/1/47.jpg
	public function DeleteOrigThumbnail()
	{
		unlink($this->orig_thumbnail_path);
	}
	public function SetNewFileId($new_file_id)
	{
		$this->new_file_id=$new_file_id;
	}
	public function ShainfoQueryData($fields_needed, $db, $sha_table_info)
	{	
		$res = "(";
		
		#PrintArr($sha_table_info, "Sha Table Info");
		foreach ($fields_needed as $field)
		{
			${$field} = $sha_table_info["$field"];
		#	echo "<br>Field needed: $field  ${$field} ";
			
			if ( $field == "file_sha512_hashes.file_id" )
			{
				${$field} = $this->new_file_id;
			}
			$cleanfield = ${$field};
			CleanInput($cleanfield);
			
			$enclosedfield=EncloseOrNull($cleanfield, "'");
			//$res .= "$field = $enclosedfield, ";
			$res .= "$enclosedfield, ";
		}
		$res=TrimComma($res);
		$res .= ")";
		//	echo "Res: $res";
		return $res;		
	}
	public function ImageinfoQueryData($fields_needed, $db)
	{
		$res = "(";
		
		foreach ($fields_needed as $field)
		{
			${$field}=$this->{$field};
		#	echo "<br>This image field: $field " . $this->{$field};
			if ($field=="imageinfo.file_id")
			{
				${$field}=$this->new_file_id;
			}
			
			$cleanfield = ${$field};
			CleanInput($cleanfield);
			
			$enclosedfield=EncloseOrNull($cleanfield, "'");
			//$res .= "$field = $enclosedfield, ";
			$res .= "$enclosedfield, ";
		}
		$res=TrimComma($res);
		$res .= ")";
		//	echo "Res: $res";
		return $res;
	}
	public function FileinfoQueryData($fields_needed, $db)
	{
		$res = "(";
		
		foreach ($fields_needed as $field)
		{	${$field}=$this->{$field};
			if ($field=="fileinfo.whenexported")
			{	${$field}=$db->datime_of_export;
		//	echo "Sending DB datime of export: " . $db->datime_of_export;
			}
			else if ($field=="fileinfo.prevdb_file_id")
			{	$file_id="fileinfo.file_id";
	//		echo "This file id property: " . $this->$file_id;
				${$field}=$this->$file_id;
			//	${$field}=$this->$
			}
			else if ($field=="fileinfo.mostrecentprevdb")
			{
				${$field}=$db->name;
			}
			else if ($field=="fileinfo.forsite")
			{	#echo "Forsite field: ${$field} --";
				if (${$field}===null)
				{	
					${$field}="unspecified";
					echo "aRGH NULL FIELD!";
				}
			}
			
		//	$res .= "
		//	echo "Field: $field" .  ${$field};
			$cleanfield = ${$field};
			CleanInput($cleanfield);
		//	$enclosedfield=EncloseOrNull(${$field}, "'");
			$enclosedfield=EncloseOrNull($cleanfield, "'");
			//$res .= "$field = $enclosedfield, ";
			$res .= "$enclosedfield, ";
		//	echo "$enclosedfield<br>";
		
		}
		$res=TrimComma($res);
		$res .= ")";
	//	echo "Res: $res";
		return $res;
	
	}
	

}
