<?php
$current_organizer="idea";
require ("../lib-abdesk.php");

CheckCookie();
session_start();

$variables_to_initialize = array(
	"ideas"
);

InitializeVariables($variables_to_initialize);

function GoBackToFormWithError($err)
{
	$_SESSION['idea_organizer_multiadder_error']=$err;
	header("Location: multi_idea_adder_form.php");
	exit;
}

function array_idiff($array1, $array2) 
{ 
	foreach ($array1 as $key=>$element) 
	{ 
	     foreach($array2 as $key2=>$element2) 
	     { 
	         if (strtolower($element) == strtolower($element2)) 
	         { 
	             unset($array1[$key]); 
	         } 
	     } 
	} 
	$diff = array_values($array1);
	return $diff; 
}

$sessprefix="idea_organizer_multiadder";
$varstoget=array("ideas", "sourcenotes", "sepmeth", "whenotedstring", "quoteorld", "reverse_input_order", "quoteorld", "radiobox_selected_idea_db", "lock");

foreach ($varstoget as $var)
{
	$sessvar=$sessprefix . "_$var";
	$_SESSION[$sessvar]=GetFromArray($_POST, $var);
}

$quoteorld=GetFromArray($_POST, 'quoteorld');
$radiobox_selected_idea_db=GetFromArray($_POST, 'radiobox_selected_idea_db');
$lock=GetFromArray($_POST, 'lock');

$idea_db_to_use=$radiobox_selected_idea_db;

if (!$idea_db_to_use)
{
	GoBackToFormWithError("no database selected");
	exit;
}


$handle=ConnectToDb($idea_db_to_use, false, "dont die");

if ($handle=="mysql_pconnect error" || $handle=="mysql_select_db error")
{	DisplayWithError(mysql_error(), 2);
	
	if ($handle=="mysql_pconnect error")
	{	
		GoBackToFormWithError("mysql_pconnect error");
		exit;
	}
	else if ($handle=="mysql_select_db error")
	{	$uc_db=ucwords($radiobox_selected_idea_db);
		DisplayWithError($uc_db, 3);
		GoBackToFormWithError("mysql_select_db error");
		exit;
	}
}

$rawideas = ltrim($_POST['ideas']);

if (!$rawideas)
{	GoBackToFormWithError("no ideas");
	exit;
}

$sourcenotes=GetFromArray($_POST, 'sourcenotes');
$sepmeth=GetFromArray($_POST, 'sepmeth');
$reverse_input_order=GetFromArray($_POST, 'reverse_input_order');

if ($sepmeth=="parag" || $sepmeth=="astrolog")
	//Currently the only two sepmeths where we need to process the date field.
{	$whenotedstring=GetFromArray($_POST, 'whenotedstring');
	if ($whenotedstring)
	{
		if (($timestamp = strtotime($whenotedstring)) === false)
		{	GoBackToFormWithError("invalid date in date noted field");
			exit;
		}
		else
		{
			$whenoted=date("Y-m-d H:i:s", $timestamp);
			CleanInput($whenotedstring);
			$finalwhenotedstring=EncloseOrNull($whenotedstring, "'");
			
			$finalwhenoted=EncloseOrNull($whenoted, "'");
			unset($whenoted);
			unset($whenotedstring);
		}
	}
	else
	{	$finalwhenoted="now()";
		$finalwhenotedstring="null";
	}
}

CleanInput($sourcenotes);
$sourcenotes=EncloseOrNull($sourcenotes, "'");

if ($sepmeth=="parag")
{	$arr_ideas=explode("\r\n\r\n", $rawideas);
}
else
{
	$arr_ideas=explode("\r\n", $rawideas);
}


$numofideas=0;
$numoflines=count($arr_ideas);

	$linenum=0;

if ($sepmeth=="date")
	//Begin each idea with a date before a period, like "16:22 4/28/2009."
{
	foreach ($arr_ideas as $line)
	{	//First, we try to grab the date.
		$periodloc=strpos($line, ".");
		$possible_date=substr($line, 0, $periodloc);
		
		if ($idea_organizer_multi_adder__removes_commas_from_dates_before_periods_when_using_date_sepmeth)
		{	$possible_date=str_replace(",", " ", $possible_date);
		}
		
		
		if (preg_match('#[0-9]#',$possible_date))
		{
			$timestamp = strtotime($possible_date);
		}
		else
		{	$timestamp=false;
			#echo "<h3>possible timestamp doesn't have a number in it!</h3>";
			
		}
		#echo "<h3>TIMESTAMP: $timestamp</h3>";
		
		if ( $timestamp === false)
		{	//No valid date here.
			if ($numofideas==0)
			{	//No idea text is allowed before a date is found, so, if we find some, we have
				//to go back to the form with an error.
				DisplayWithError($linenum);
				DisplayWithError($line, 2);
				GoBackToFormWithError("invalid date on line");
				exit;
			}
			//If a date was already found previously, we just add this line to the current idea.
			$ideas[$numofideas] .= "\r\n$line";
		}
		else	
		{	//There is a valid date here.
			$numofideas++;
			$whenotedstring[$numofideas]=EncloseOrNull($possible_date, "'");
			$whenoted[$numofideas]=date("Y-m-d H:i:s", $timestamp);
			$whenoted[$numofideas]=EncloseOrNull($whenoted[$numofideas], "'");
			if ( !isset($ideas[$numofideas] ) )
			{
				$ideas[$numofideas]="";
			}
			$ideas[$numofideas] .= "$line";
		}
		$linenum++;
	}
}
else if ($sepmeth=="notecase" || $sepmeth=="notecasedate")
{
	$dt_found=false;
	$linecounter=0;
	$date_created_found=false;
	$date_modified_found=false;
	$date_before_period_found=false;
	$dd_found=false;
	$closing_dt_found=false;
	
	foreach ($arr_ideas as $line)
	{	
		if ($line=="<DL>" || $line=="</DD>" || $line=="</DL>" || $line=="</BODY>" || $line=="</HTML>")
		{
			#echo "<h3>Skipped line $linecounter - line $line</h3>";
			$linecounter++;
		
			continue;
		}

		if (!$dt_found)
		{	
			
			
			//If no <DT> line was already found, we must look for one. We ignore
			//all lines until one is found.
			$dt_loc=strpos($line, "<DT>");
			
			$printable_line=str_replace("<", "&lt;", $line);
			
		#	echo "<h3>Line $linecounter - no dt found yet - dt_loc $dt_loc  line: $printable_line</h3>";
			
			#echo "<h3>dt_loc $dt_loc - Line - before dt found - $line</h3>";
			
			$closing_dt_loc=strpos($line, "</DT>");
				
			#echo "<h3>Closing dt loc: $closing_dt_loc  line: $printable_line</h3>";
				
			if ($dt_loc===0)
			{
				#echo "inside dt loc 0 thing";
				
				$dt_found=true;
				$dt_loc=false;
								
				$numofideas++;
				$linecounter++;
				$line_without_dt=str_replace("<DT>", "", $line);
				
				
				
				if ($closing_dt_loc===0 || $closing_dt_loc > 1)
				{
					
					
					$line_without_dt=str_replace("</DT>", "", $line_without_dt);
					
					$clean_line_without_dt=$line_without_dt;
				
					CleanInput($clean_line_without_dt);
					
					$title[$numofideas]=EncloseOrNull($clean_line_without_dt, "'");

					$closing_dt_found=true;
				}
				else
				{
					$closing_dt_found=false;
					
					
					$partial_title=$line_without_dt;
					
					#echo "<h3>Yay partial title $partial_title</h3>";
					
				}
				
			#	echo "continuing now";
			//	echo "Title: $title[$numofideas]<p>";
				continue; //Nothing else needed, so we go to the next line.
			}
			else
			{	$linecounter++;
			#	echo "continuing here";
				continue;
			}
		}
		if ($dt_found)
		{	#echo "<h3>Within DT";
		
			if (!$closing_dt_found) 
			{#	echo " No closing DT yet";
			}
			else
			{	#echo " With closing DT";
			}
			
			$printable_line=str_replace("<", "&lt;", $line);
			
			#echo "Line $linecounter line: $printable_line</h3>";
			//After a <DT> is found, then, we have to look for the date_created,
			//if we haven't already found it.
			
			if ( !$closing_dt_found)
			{
				
			
		#	echo "<h3>Line $linecounter - no dt found yet - dt_loc $dt_loc  line: $printable_line</h3>";
			
			#	echo "<h3> No closing_dt_found!  line $linecounter  line: $printable_line </h3>";
				
				$closing_dt_loc=strpos($line, "</DT>");
				
				if ( $closing_dt_loc===0 || $closing_dt_loc > 1 )
				{
					$line_without_dt=str_replace("</DT>", "", $line);
					
					$complete_title=$partial_title . $line_without_dt;
					
					$clean_complete_title=$complete_title;
				
					CleanInput($complete_title);
					
					$title[$numofideas]=EncloseOrNull($complete_title, "'");
					
					$closing_dt_found=true;
					$closing_dt_loc=false;
				}
				else
				{
				#	echo "<h3> partial title $partial_title</h3>";
				#	echo "<h3> partial title </h3>";
					$partial_title .= $line;
					
				}
				
				$linecounter++;
				continue;
				
			}
			
			
			if (!$date_created_found)
			{
				$date_created_loc=strpos($line, "<!--property:date_created=");
				if ($date_created_loc===0)
				{	//echo "Line: $line ";
					$date_created_found=true;
					$date_created_loc=false;
					$equal_loc=strpos($line, "=");
					$date_created=substr($line, $equal_loc+1);
					$date_created=substr($date_created, 0, -3);
					$formatted_date_created=date("Y-m-d H:i:s", $date_created);
					
					//if ($sepmeth=="notecase")
					//{
					//If sepmeth is "notecasedate", these might get overwritten later.
						$whenotedstring[$numofideas]=EncloseOrNull($formatted_date_created, "'");
						$whenoted[$numofideas]=$whenotedstring[$numofideas];
					//}
					$thisyear=date("Y", $date_created);
					$thismonth=date("m", $date_created);
					$thisday=date("d", $date_created);
					$thistime=date("H:i:s", $date_created);
	
					//echo " $thisyear $thismonth $thisday $thistime ";
					
					$datestartyear[$numofideas]=EncloseOrNull($thisyear, "'");
					$datestartmonth[$numofideas]=EncloseOrNull($thismonth, "'");
					$datestartday[$numofideas]=EncloseOrNull($thisday, "'");
					$datestarttime[$numofideas]=EncloseOrNull($thistime, "'");
					
					if (!isset($ideas[$numofideas] ) )
					{
						$ideas[$numofideas]="";
					}
					$ideas[$numofideas] .= "\r\n$line";
			
				//	echo "Date_created: $date_created $formatted_date_created";
					$linecounter++;
					continue;
				}
				else
				{	$linecounter++;
					DisplayWithError($linecounter);
					$displayable_line=str_replace("<", "&lt;", $line);
					DisplayWithError($displayable_line, 2);
						DisplayWithError("created", 3);
				//	echo "Line: $displayable_line ";
					
					GoBackToFormWithError("invalid notecase node date on line");
					
					exit;
				}
			}
			
			if (!$date_modified_found)
			{
				$date_modified_loc=strpos($line, "<!--property:date_modified=");
				if ($date_modified_loc===0)
				{//	echo "Line: $line ";
					$date_modified_found=true;
					$date_modified_loc=false;
					$equal_loc=strpos($line, "=");
					$date_modified=substr($line, $equal_loc+1);
					$date_modified=substr($date_modified, 0, -3);
					$formatted_date_modified=date("Y-m-d H:i:s", $date_modified);
					
					
					$thisyear=date("Y", $date_modified);
					$thismonth=date("m", $date_modified);
					$thisday=date("d", $date_modified);
					$thistime=date("H:i:s", $date_modified);
	
					//echo " $thisyear $thismonth $thisday $thistime ";
	
					$datendyear[$numofideas]=EncloseOrNull($thisyear, "'");
					$datendmonth[$numofideas]=EncloseOrNull($thismonth, "'");
					$datendday[$numofideas]=EncloseOrNull($thisday, "'");
					$datendtime[$numofideas]=EncloseOrNull($thistime, "'");
					
					$ideas[$numofideas] .= "\r\n$line";
					//echo "date_modified: $date_modified $formatted_date_modified";
					$linecounter++;
					continue;
				}
				else
				{	$linecounter++;
					DisplayWithError($linecounter);
					$displayable_line=str_replace("<", "&lt;", $line);
					DisplayWithError($displayable_line, 2);
					DisplayWithError("modified", 3);
					//echo "Line: $displayable_line ";
					
					GoBackToFormWithError("invalid notecase node date on line");
					
					exit;
				}
			}
			
			if (!$dd_found)
			{
				if ($line=="<DD>")
				{	$dd_found=true;
					$linecounter++;
					continue;
				}
			}
			
			
			//OK, once we've found the two dates, we just have to look out for
			//new DT lines.  Any other lines get added to the current idea, but
			//if another DT is found, then, a new idea gets started.  
			
			$dt_loc=strpos($line, "<DT>");
			if ($dt_loc===0)
			{	#echo "<h3>New DT found!</h3>";
				$dt_found=true; # 21:17:04 1/19/2015.  Have to reset this to false so the redo
									# of this line
									# will handle the DT properly.
				$dt_loc=false;
				
				if ($dd_found && !$date_before_period_found && $sepmeth=="notecasedate")
				{
					DisplayWithError($linecounter);
					DisplayWithError($line, 2);
					
					GoBackToFormWithError("no date before period found in notecase node");
					exit;
				}
				//if (!$dd_found)
				//{
		//			$whenotedstring[$numofideas]=EncloseOrNull($formatted_date_created, "'");
	//				$whenoted[$numofideas]=$whenotedstring[$numofideas];
	//			}
				$dd_found=false;
				$date_before_period_found=false;
				$date_created_found=false;
				$date_modified_found=false;
				
				$closing_dt_found=false;
				$closing_dt_loc=false;
					
				$numofideas++;
				#$linecounter--;
				$linecounter++;  // `20:20:49 1/19/2015.  Have to redo this line so as to avoid
				// duplicating the code for getting the title - something complicated by having to get
				// multiple lines for a title.
				
				
				$line_without_dt=str_replace("<DT>", "", $line);
				
				$closing_dt_loc=strpos($line, "</DT>");
				
				if ($closing_dt_loc===0 || $closing_dt_loc > 1)
				{
					
					
					$line_without_dt=str_replace("</DT>", "", $line_without_dt);
					
					$clean_line_without_dt=$line_without_dt;
				
					CleanInput($clean_line_without_dt);
					
					$title[$numofideas]=EncloseOrNull($clean_line_without_dt, "'");

					$closing_dt_found=true;
				}
				else
				{
					$closing_dt_found=false;
					
					
					$partial_title=$line_without_dt;
					
				#	echo "<h3>Yay partial title $partial_title</h3>";
					
				}
				
				
			#	$line_without_dt=str_replace("<DT>", "", $line);
			#	$line_without_dt=str_replace("</DT>", "", $line_without_dt);
				
			#	$clean_line_without_dt=$line_without_dt;
				
			#	CleanInput($clean_line_without_dt);
				
			#	$title[$numofideas]=EncloseOrNull($clean_line_without_dt, "'");
				
				
				//$title[$numofideas]=EncloseOrNull($line_without_dt, "'");
				
				//echo "Title: $title[$numofideas]<p>";
				continue; //Nothing else needed, so we go to the next line.
			}
			else
			{	//OK, not a DT line.
			//	echo "Not a dt line";
				if ($sepmeth=="notecasedate")
				{	//echo "Line: $line ";
					//Then we have to look for a date before a period, if we haven't
					//already found one.
				
					if (!$date_before_period_found && $dd_found)
					{
						$periodloc=strpos($line, ".");
						if ($periodloc!==false)
						{
							$possible_date=substr($line, 0, $periodloc);
						
						//Since NoteCase's default date format uses dashes, and PHP's
						//date parser dislikes dashes, we must convert them.
							$dashpos=strpos($line, "-");
							if ($dashpos!==false)
							{
								$possible_date=str_replace("-", "/", $possible_date);
							}
							
							if (($timestamp = strtotime($possible_date)) === false)
							{
								DisplayWithError($linecounter);
								DisplayWithError($line, 2);
								GoBackToFormWithError("invalid date on line");
								exit;
							}
							$date_before_period_found=true;
							$formatted_timestamp=date("Y-m-d H:i:s", $timestamp);
						//	echo "$formatted_timestamp";
							
							if ($dashpos!==false)
							{
								$whenotedstring[$numofideas]=EncloseOrNull($formatted_timestamp, "'");
							}
							else
							{	$whenotedstring[$numofideas]=EncloseOrNull($possible_date, "'");
							}
							$whenoted[$numofideas]=EncloseOrNull($formatted_timestamp, "'");
							//$whenotedstring[$numofideas];
							
						}
							
							//If a date was already found previously, we just add this line to the current idea.
						//$ideas[$numofideas] .= "\r\n$line";
						
					}
				}
				$ideas[$numofideas] .= "\r\n$line";
				$linecounter++;
				continue;
			}
		}
	}
	
	if ($sepmeth=="notecasedate" && $dd_found && !$date_before_period_found)
	{
		DisplayWithError($linecounter);
		DisplayWithError($line, 2);

		GoBackToFormWithError("no date before period found in notecase node");
		exit;
	}
}
else if ($sepmeth=="dividerdate")
{	//Start each idea with *(*)* and on any line after that, a date before a period.

	$divider_found=false;
	$linecounter=0;
	$datefound=false;
	$dividerloc=false;
	
	foreach ($arr_ideas as $line)
	{		
		if (!$divider_found)
		{	//If no divider already found, then we have to look for a *(*)* divider.
			$trimmed_line=trim($line);

			if ($trimmed_line=="*(*)*")		// If the line contains nothing but *(*)* and possibly
															//some whitespace...
			{	
				$divider_found=true;
				$datefound=false;
				$dividerloc=false;
				$linecounter++;
				continue;
				//The divider line gets thrown away and not even added to the idea text.
				//So, the user should not put anything on the same line as the divider,
				//unless they don't mind it getting lost.
			}
			else
			{	
				$whitespacefree_line=trim($line);
				if ($whitespacefree_line!="")
				{	$dividerloc=strpos($line, "*(*)*");
					if ($dividerloc!==false)
					{	GoBackToFormWithError("text on divider line");
						exit;
					}
					GoBackToFormWithError("text found before any divider");
					exit;
				}
			}
		}
		if ($divider_found)
		{
			if (!$datefound)	//No date found yet, so we need to find one.
			{
				$whitespacefree_line=trim($line);
				if ($whitespacefree_line=="")
				{	//$ideas[$numofideas] .= "\r\n$line";
					$linecounter++;
					continue;	//Skip to the next line if it's just whitespace.
				}
				
				$periodloc=strpos($line, ".");
				$possible_date=substr($line, 0, $periodloc);

				if (($timestamp = strtotime($possible_date)) === false)
				{	DisplayWithError($linecounter);
					DisplayWithError($line, 2);
					GoBackToFormWithError("invalid date on line");
					exit;
				}
				else
				{	$datefound=true;
					$numofideas++;
					$whenotedstring[$numofideas]=EncloseOrNull($possible_date, "'");
					$whenoted[$numofideas]=date("Y-m-d H:i:s", $timestamp);
					$whenoted[$numofideas]=EncloseOrNull($whenoted[$numofideas], "'");
					if (!isset($ideas[$numofideas] ) )
					{	
						$ideas[$numofideas]="";
					}
					$ideas[$numofideas] .= "$line";
					continue;
				}
			}
			else if ($datefound)	
				//Date already found, in which case we're looking for dividers.
			{
		
				$trimmed_line=trim($line);
				if ($trimmed_line=="*(*)*")		// If the line contains nothing but *(*)* and possibly
															//some whitespace...
				{	
					$divider_found=true;
					$datefound=false;
					$dividerloc=false;
					$linecounter++;
					continue;
				}
				$ideas[$numofideas] .= "\r\n$line";
				$linecounter++;			
			}
		}
	}
	if ($numofideas==0)
	{	GoBackToFormWithError("no date found after divider");
		exit;
	}
}
else if ($sepmeth=="parag")
	//Separate each idea with a one-line paragraph break.
	//The simplest sepmeth.
{	foreach ($arr_ideas as $line)
	{
		$numofideas++;
		$whenotedstring[$numofideas]=$finalwhenotedstring;
		$whenoted[$numofideas]=$finalwhenoted;
		
		if ( !isset($ideas[$numofideas] ) )
		{
			$ideas[$numofideas]="";
		}
		$ideas[$numofideas] .= "$line";
	}
}
else if ($sepmeth=="astrolog")
{	//Astrolog command lines, like "-qa Apr 28 2009 16:22" (etc.)
	
	$any_qa_found=false;
	
	foreach ($arr_ideas as $line)
	{	$trimmed_line=trim($line);
		if (!$any_qa_found)
		{	
			//If no -qa already found, then we have to look for a -qa.

			$qaloc=strpos($trimmed_line, "-qa ");
			
			if ($qaloc !==0) 
			{	
				$whitespacefree_line=trim($line);
				if ($whitespacefree_line!="")
				{	
					GoBackToFormWithError("text found before any qa");
					exit;
				}
				else	//A blank line.
				{	continue; //We just skip whitespace lines.
				}
			}
			else	//The line starts with "-qa ".
			{
				$any_qa_found=true;
			}
		}
		
		if ($any_qa_found==true)
		{	
			$qaloc=strpos($trimmed_line, "-qa ");
			if ($qaloc===0)
			{	$qa_on_this_line=true;
			}
			else
			{	$qa_on_this_line=false;
			}
			
			if ($qa_on_this_line)
			{
				$numofideas++;
				if (!isset ($ideas[$numofideas] ) )
				{
					$ideas[$numofideas]="";
				}
				$ideas[$numofideas] .= "$line";
				
				$whenotedstring[$numofideas]=$finalwhenotedstring;
				$whenoted[$numofideas]=$finalwhenoted;
			
				$actual_qaloc=strpos($line, "-qa ");
				$datestart=$actual_qaloc+4;
				$colonloc=strpos($line, ":");
				if ($colonloc)
				{	$thirdcharaftercolonloc=$colonloc+3;
					$aftercolonchar=substr($line,$thirdcharaftercolonloc,1);
					if ($aftercolonchar==":")
					{	$datend=$colonloc+6;
					}
					else
					{	$datend=$thirdcharaftercolonloc;
					}
					$datend -= 4;
					$possible_date=substr($line, $datestart, $datend);
				}
				else
				{	
					$possible_date=substr($line, $datestart);
				}
				$dateparts=explode(" ", $possible_date);
				
				if (!is_numeric($dateparts[0]) )
				{
					$thistimestamp=strtotime($dateparts[0]);
				
					$thismonth=date("n", $thistimestamp);
				}
				else
				{	$thismonth=$dateparts[0];
				}
				$thisday=$dateparts[1];
				$thisyear=$dateparts[2];
				$thistime=$dateparts[3];
				
				$maindateyear[$numofideas]=EncloseOrNull($thisyear, "'");
				$maindatemonth[$numofideas]=EncloseOrNull($thismonth, "'");
				$maindateday[$numofideas]=EncloseOrNull($thisday, "'");
				$maindatetime[$numofideas]=EncloseOrNull($thistime, "'");
			}
			else if (!$qa_on_this_line)
			{	$ideas[$numofideas] .= "\r\n$line";
			}
		}
	}
}
else if ($sepmeth="datenclosed")
{	//Enclose each idea between two identical dates, both alone on a line.
	$datefound=false;
	$linecounter=0;
	$stillonfirstdateline=false;
	
	foreach ($arr_ideas as $line)
	{	
		if (!$datefound)
		{	
			$whitespacefree_line=trim($line);
			$whitespacefree_line=rtrim($whitespacefree_line, ".");
				//Periods are trimmed off the right side, and whitespace from both sides of
				//the line.

			if ($whitespacefree_line)	//If there's text on the trimmed line...
			{	//Then we look for a valid date.
				if (($timestamp = strtotime($whitespacefree_line)) === false)
				{	DisplayWithError($linecounter);
					DisplayWithError($line, 2);
					GoBackToFormWithError("invalid date on line");
					exit;
				}
				
				$datefound=true;
				$numofideas++;
				
				$originaldateline=$whitespacefree_line;
				$whenotedstring[$numofideas]=EncloseOrNull($originaldateline, "'");
				$whenoted[$numofideas]=date("Y-m-d H:i:s", $timestamp);
				$whenoted[$numofideas]=EncloseOrNull($whenoted[$numofideas], "'");
			
				$stillonfirstdateline=true;
				
			}
		}
		if ($datefound)
		{	if (!$stillonfirstdateline)
			{	$whitespacefree_line=trim($line);
				$whitespacefree_line=rtrim($whitespacefree_line, ".");
				
				if ($whitespacefree_line)
				{	
					if ($whitespacefree_line==$originaldateline)
					{	$datefound=false;
					}
				}
			}
			if (!isset($ideas[$numofideas]) )
			{
				$ideas[$numofideas] = "";
			}
			$ideas[$numofideas] .= "\r\n$line";
			$stillonfirstdateline=false;
		}
		$linecounter++;
	}
}


if ($reverse_input_order)
{	$ideas=array_reverse($ideas, true);
}

switch ($sepmeth)
{
	case "astrolog": $query_to_issue="INSERT INTO ideainfo (repository, whenotedstring, whenoted, whenadded, lastread, maindateyear, maindatemonth, maindateday, maindatetime) VALUES\n";
	break;
	
	case "notecase":
	case "notecasedate":	$query_to_issue="INSERT INTO ideainfo (repository, title, whenotedstring, whenoted, whenadded, lastread, datestartyear, datestartmonth, datestartday, datestarttime, datendyear, datendmonth, datendday, datendtime) VALUES\n"; break;
	
	default: $query_to_issue="INSERT INTO ideainfo (repository, whenotedstring, whenoted, whenadded, lastread) VALUES\n";
}

/*
if ($sepmeth!="astrolog" && $sepmeth!="notecase" && $sepmeth!="notecasedate")
{
	$query_to_issue="INSERT INTO ideainfo (repository, whenotedstring, whenoted, whenadded, lastread) VALUES\n";
}
else	if ($sepmeth=="astrolog")//More fields to insert if Astrolog sepmeth was used.
{	$query_to_issue="INSERT INTO ideainfo (repository, whenotedstring, whenoted, whenadded, lastread, maindateyear, maindatemonth, maindateday, maindatetime) VALUES\n";
}
else if ($sepmeth=="notecase" || $sepmeth=="notecasedate")
{
	$query_to_issue="INSERT INTO ideainfo (repository, whenotedstring, whenoted, whenadded, lastread, datestartyear, datestartmonth, datestartday, datestarttime, datendyear, datendmonth, datendday, datendtime) VALUES\n";
}
	*/

	//PrintArr($ideas);
	
switch ($sepmeth)
{
	case "astrolog": 
		foreach ($ideas as $ideanum => $idea)
		{
			$query_to_issue .= "\n('y', $whenotedstring[$ideanum], $whenoted[$ideanum], now(), now(), $maindateyear[$ideanum], $maindatemonth[$ideanum], $maindateday[$ideanum], $maindatetime[$ideanum]), \n";
		}
	break;
	
	case "notecase":
	case "notecasedate":
		foreach ($ideas as $ideanum => $idea)
		{	#echo "Ideanum: $ideanum ";
		
		$query_to_issue .= "\n('y', $title[$ideanum], $whenotedstring[$ideanum], $whenoted[$ideanum], now(), now(), $datestartyear[$ideanum], $datestartmonth[$ideanum], $datestartday[$ideanum], $datestarttime[$ideanum], $datendyear[$ideanum], $datendmonth[$ideanum], $datendday[$ideanum], $datendtime[$ideanum]), \n";
		}
	break;
	
	default:
		foreach ($ideas as $ideanum => $idea)
		{	//echo "WOOF";
		$query_to_issue .= "\n('y', $whenotedstring[$ideanum], $whenoted[$ideanum], now(), now()), \n";
		}
		break;
}

/*
if ($sepmeth!="astrolog" && $sepmeth!="notecase" && $sepmeth!="notecasedate")
{
	foreach ($ideas as $ideanum => $idea)
	{	
	$query_to_issue .= "\n('y', $whenotedstring[$ideanum], $whenoted[$ideanum], now(), now()), \n";

	}
}
else if ($sepmeth=="astrolog")
{	foreach ($ideas as $ideanum => $idea)
	{
		$query_to_issue .= "\n('y', $whenotedstring[$ideanum], $whenoted[$ideanum], now(), now(), $maindateyear[$ideanum], $maindatemonth[$ideanum], $maindateday[$ideanum], $maindatetime[$ideanum]), \n";
	}
}
else if ($sepmeth=="notecase" || $sepmeth=="notecasedata")
{
	foreach ($ideas as $ideanum => $idea)
	{
	$query_to_issue .= "\n('y', $whenotedstring[$ideanum], $whenoted[$ideanum], now(), now(), $datestartyear[$ideanum], $datestartmonth[$ideanum], $datestartday[$ideanum], $datestarttime[$ideanum]), $datendyear[$ideanum], $datendmonth[$ideanum], $datendday[$ideanum], $datendtime[$ideanum]), \n";
	}
}
*/
	

echo "<html><head><title>ABDesktop Multiple Idea Adder Results</title>
<link rel=stylesheet href=\"css/i.css\" type=\"text/css\">
<style type=\"text/css\"> 
</style><body><center>";
AllOrganizerNavLinks();
echo "<h1>ABDesktop Multiple Idea Adder Results</h1>
<p>";
$display_name_of_idea_db_being_used=ucwords($idea_db_to_use);

$query_to_issue = substr($query_to_issue, 0, -3);

echo "<big>DB: $display_name_of_idea_db_being_used<p>
Number of ideas: $numofideas</big><p>";
$addmorelink="<a href=\"http://localhost/abdesk/ideas/multi_idea_adder_form.php?db=$idea_db_to_use";

if ($lock)
{	$addmorelink .= "&lock=y";
}
$addmorelink .= "\" class='arlink'>Add More</a>";

echo "$addmorelink</center><p><div id='maintext'>";

echo "$query_to_issue<p>";

$origquery=$query_to_issue;
$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

$idea_id = mysql_insert_id();

if ($quoteorld=="longdesc")
{	$ideatable="longdesc";
	$notideatable="quote";
}
else
{	$ideatable="quote";
	$notideatable="longdesc";
}
$dispideatable=ucwords($ideatable);
$dispnotideatable=ucwords($notideatable);

$ldquery = "INSERT INTO idea$ideatable (idea_id, $ideatable) VALUES ";

$query_to_issue=$ldquery;

$thisid=$idea_id;
foreach ($ideas as $ideanum => $idea)
{	
	CleanInput($idea);
	$longdesc=EncloseOrNull($idea, "'");
	$query_to_issue .= "($thisid, $longdesc), \n\n";
	$thisid++;
}
$query_to_issue = substr($query_to_issue, 0, -4);
echo "<p><big><b>$dispideatable query:</big></b> <pre>$query_to_issue ";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

$thisid=$idea_id;

echo "<p><br><hr><p><b>Main query:</b> $origquery<p><br>";

$snquery = "INSERT INTO ideasourcenotes (idea_id, sourcenotes) VALUES \n";
$query_to_issue=$snquery;
foreach ($ideas as $ideanum => $idea)
{	
	CleanInput($idea);
	$longdesc=EncloseOrNull($idea, "'");
	$query_to_issue .= "\n($thisid, $sourcenotes), \n";
	$thisid++;
}
$query_to_issue = substr($query_to_issue, 0, -3);
echo "<hr><p><br><b>Sourcenotes query:</b> $query_to_issue";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="INSERT INTO idea$notideatable (idea_id, $notideatable) VALUES \n";
$thisid=$idea_id;

foreach ($ideas as $ideanum => $idea)
{
	$query_to_issue .= "\n($thisid, NULL), \n";
	$thisid++;
}
$query_to_issue = substr($query_to_issue, 0, -3);
echo "<hr><p><br><b>$dispnotideatable query:</b> $query_to_issue";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

echo "</pre><center><p>$addmorelink";

echo"<p><br><br>";
AllOrganizerNavLinks();
echo "</body></html>";
